SystemOrganization addCategory: #'Phidget-VMMaker-Plugins'!
SystemOrganization addCategory: #Phidget!
SystemOrganization addCategory: #'Phidget-Core'!
SystemOrganization addCategory: #'Phidget-Lab'!
SystemOrganization addCategory: #'Phidget-Tests'!
SystemOrganization addCategory: #'Phidget-EToys'!

SmartSyntaxInterpreterPlugin subclass: #PhidgetPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-VMMaker-Plugins'!

!PhidgetPlugin commentStamp: 'pt 5/3/2009 13:55' prior: 0!
A PhidgetPlugin is a plugin to enable the use of Phidgets (For more information about Phidgets see www.phidgets.com).

Instance Variables: - none -
!

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/6/2009 17:20'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:58'!
requiresCrossPlatformFiles
	"default is ok for most, any plugin needing platform specific files must say so"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:57'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^true! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'fs 7/5/2009 20:46'!
cStringOf: byteArray
	
	self returnTypeC: 'char* '.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: byteArray ) not and:
		 [ ( interpreterProxy isBytes: byteArray ) ] ).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(char*)(byteArray + 4)'! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'lk 6/14/2009 18:14'!
initialiseModule
	"Initialise the module"

	self export: true.
	self cCode: 'phidgetPlugin_Initialise()'.
	^ 1! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 11:46'!
phidgetIdOf: byteArray
	"Return the PhidgetId of the given Smalltalk bytes object, or nil if oop is not a PhidgetId."

	self returnTypeC: 'PhidgetId* '.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: byteArray ) not and:
		 [ ( interpreterProxy isBytes: byteArray ) and:
		 [ ( interpreterProxy slotSizeOf: byteArray ) = ( self cCode: 'sizeof(PhidgetId)' ) ] ] ).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(PhidgetId*)(byteArray + 4)'! !

!PhidgetPlugin methodsFor: 'Phidget: Accelerometer' stamp: 'sp 6/18/2009 17:12'!
primAccelerometerCreate

	self primitive: 'primAccelerometerCreate' parameters: #().
	^ self cCode: 'phidgetAccel_Create()'! !

!PhidgetPlugin methodsFor: 'Phidget: Advanced Servo' stamp: 'sp 6/26/2009 05:56'!
primAdvancedServoCreate

	self primitive: 'primAdvancedServoCreate' parameters: #().
	^ self cCode: 'phidgetAdvServo_Create()'! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 14:29'!
primClose: phidgetIdArray

	| phidgetId |
	self primitive: 'primClose' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_Close(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:43'!
primGetAdvancedServoAcceleration: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoAcceleration' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetAcceleration(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:43'!
primGetAdvancedServoAccelerationMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoAccelerationMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetAccelerationMax(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:43'!
primGetAdvancedServoAccelerationMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoAccelerationMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetAccelerationMin(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:43'!
primGetAdvancedServoCurrent: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoCurrent' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetCurrent(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:50'!
primGetAdvancedServoVelocity: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoVelocity' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetVelocity(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:50'!
primGetAdvancedServoVelocityLimit: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoVelocityLimit' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetVelocityLimit(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:54'!
primGetAdvancedServoVelocityMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoVelocityMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetVelocityMax(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:54'!
primGetAdvancedServoVelocityMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoVelocityMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetVelocityMin(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Analog Sensor' stamp: 'lk 6/15/2009 15:56'!
primGetAnalogSensorValue: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAnalogSensorValue' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAnalogSensor_GetValue(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 22:04'!
primGetAxisAcceleration: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAxisAcceleration' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAxis_GetAcceleration(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 22:05'!
primGetAxisAccelerationMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAxisAccelerationMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAxis_GetAccelerationMax(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 22:05'!
primGetAxisAccelerationMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAxisAccelerationMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAxis_GetAccelerationMin(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Input' stamp: 'lk 6/15/2009 15:57'!
primGetDigitalInputValue: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetDigitalInputValue' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalInput_GetValue(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 6/15/2009 15:57'!
primGetDigitalOutputValue: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetDigitalOutputValue' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalOutput_GetValue(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'sp 6/18/2009 17:02'!
primGetDoubleSensitivity: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetIndexedDoubleSensitivity' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetComponent_GetIndexedDoubleSensitivity(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'sp 6/18/2009 17:01'!
primGetIntegerSensitivity: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetIndexedIntegerSensitivity' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetComponent_GetIndexedIntegerSensitivity(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 20:25'!
primGetLastRFIDTag: phidgetIdArray

	| phidgetId tagArrayOop tagArray |
	self primitive: 'primGetLastRFIDTag' parameters: #(Oop).
	self var: #tagArray type: 'char *'.
	self var: #phidgetId type: 'PhidgetId'.
	
	tagArrayOop := interpreterProxy
		instantiateClass: interpreterProxy classByteArray
		indexableSize: 5.
	tagArray := self cCode: '(char *) (tagArrayOop + 4)'.
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetCompRFID_GetLastTag(phidgetId, tagArray)' ].
	^ tagArrayOop! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/24/2009 14:20'!
primGetMotorAcceleration: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorAcceleration' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompMotor_GetAcceleration(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/24/2009 14:21'!
primGetMotorAccelerationMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorAccelerationMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompMotor_GetAccelerationMax(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/24/2009 14:21'!
primGetMotorAccelerationMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorAccelerationMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompMotor_GetAccelerationMin(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/25/2009 12:26'!
primGetMotorCurrent: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorCurrent' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompMotor_GetCurrent(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/24/2009 14:42'!
primGetMotorVelocity: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorVelocity' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompMotor_GetVelocity(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:26'!
primGetServoPosition: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetServoPosition' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompServoMotor_GetPosition(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 23:13'!
primGetServoPositionMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetServoPositionMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompServoMotor_GetPositionMax(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/16/2009 11:54'!
primGetServoPositionMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetServoPositionMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompServoMotor_GetPositionMin(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextDisplay' stamp: 'fs 7/5/2009 20:57'!
primGetTextDisplayColumnCount: phidgetIdArray

	| phidgetId |
	self primitive: 'primGetTextDisplayColumnCount' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextDisplay_ColumnCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextDisplay' stamp: 'fs 7/5/2009 20:57'!
primGetTextDisplayRowCount: phidgetIdArray

	| phidgetId |
	self primitive: 'primGetTextDisplayRowCount' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextDisplay_RowCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:10'!
primGetTextLCDContrast: phidgetIdArray

	| phidgetId |
	self primitive: 'primGetTextLCDContrast' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_GetContrast(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 20:26'!
primHasRFIDTag: phidgetIdArray

	| phidgetId |
	self primitive: 'primHasRFIDTag' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_HasTag(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget: Interface Kit' stamp: 'lk 6/15/2009 17:14'!
primInterfaceKitCreate

	self primitive: 'primInterfaceKitCreate' parameters: #().
	^ self cCode: 'phidgetIfKit_Create()'! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:43'!
primIsAdvancedServoSpeedRampingOn: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primIsAdvancedServoSpeedRampingOn' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_IsSpeedRampingOn(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 13:01'!
primIsAttached: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsAttached' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_isAttached(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 20:26'!
primIsRFIDAntennaOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsRFIDAntennaOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_IsAntennaOn(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:27'!
primIsServoEngaged: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primIsServoEngaged' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_IsEngaged(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Simple LED' stamp: 'lk 6/15/2009 20:38'!
primIsSimpleLEDOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsSimpleLEDOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompSimpleLED_IsOn(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:00'!
primIsTextLCDBacklightOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsTextLCDBacklightOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_IsBacklightOn(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:06'!
primIsTextLCDCursorBlinking: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsTextLCDCursorBlinking' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_IsCursorBlinking(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:04'!
primIsTextLCDCursorOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsTextLCDCursorOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_IsCursorOn(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 13:01'!
primIsValid: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsValid' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_isValid(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'lk 6/14/2009 21:00'!
primLastError

	self primitive: 'primLastError' parameters: #( ).
	
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidget_LastError()' )! !

!PhidgetPlugin methodsFor: 'Phidget: Motor Control' stamp: 'sp 6/24/2009 11:55'!
primMotorControlCreate

	self primitive: 'primMotorControlCreate' parameters: #().
	^ self cCode: 'phidgetMotCon_Create()'! !

!PhidgetPlugin methodsFor: 'Component: Analog Sensor' stamp: 'lk 6/15/2009 15:56'!
primNumAnalogSensors: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumAnalogSensors' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAnalogSensor_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 17:04'!
primNumAxes: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumAxes' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAxis_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Input' stamp: 'lk 6/15/2009 15:57'!
primNumDigitalInputs: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumDigitalInputs' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalInput_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 6/15/2009 15:57'!
primNumDigitalOutputs: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumDigitalOutputs' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalOutput_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/24/2009 14:22'!
primNumMotors: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumMotors' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompMotor_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:21'!
primNumServoMotors: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumServoMotors' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 13:58'!
primOpen: phidgetIdArray withSerial: serial

	| phidgetId |
	self primitive: 'primOpen' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_Open(phidgetId, serial)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget: RFID' stamp: 'lk 6/15/2009 21:04'!
primRFIDCreate

	self primitive: 'primRFIDCreate' parameters: #().
	^ self cCode: 'phidgetRFID_Create()'! !

!PhidgetPlugin methodsFor: 'Phidget: Servo' stamp: 'lk 6/15/2009 22:19'!
primServoCreate

	self primitive: 'primServoCreate' parameters: #().
	^ self cCode: 'phidgetServo_Create()'! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:42'!
primSetAdvancedServoAcceleration: phidgetIdArray at: index to: acceleration

	| phidgetId floatAcceleration |
	self primitive: 'primSetAdvancedServoAcceleration' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatAcceleration := interpreterProxy floatValueOf: acceleration.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetAcceleration(phidgetId, index, floatAcceleration)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:49'!
primSetAdvancedServoPositionMax: phidgetIdArray at: index to: positionMax

	| phidgetId floatPositionMax |
	self primitive: 'primSetAdvancedServoPositionMax' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatPositionMax := interpreterProxy floatValueOf: positionMax.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetPositionMax(phidgetId, index, floatPositionMax)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:49'!
primSetAdvancedServoPositionMin: phidgetIdArray at: index to: positionMin

	| phidgetId floatPositionMin |
	self primitive: 'primSetAdvancedServoPositionMin' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatPositionMin := interpreterProxy floatValueOf: positionMin.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetPositionMin(phidgetId, index, floatPositionMin)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:44'!
primSetAdvancedServoSpeedRampingOn: phidgetIdArray at: index to: state

	| phidgetId |
	self primitive: 'primSetAdvancedServoSpeedRampingOn' parameters: #(Oop SmallInteger SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetSpeedRampingOn(phidgetId, index, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 10:55'!
primSetAdvancedServoVelocityLimit: phidgetIdArray at: index to: velocityLimit

	| phidgetId floatVelocityLimit |
	self primitive: 'primSetAdvancedServoVelocityLimit' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatVelocityLimit := interpreterProxy floatValueOf: velocityLimit.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetVelocityLimit(phidgetId, index, floatVelocityLimit)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 6/15/2009 15:57'!
primSetDigitalOutputValue: phidgetIdArray at: index to: value

	| phidgetId |
	self primitive: 'primSetDigitalOutputValue' parameters: #(Oop SmallInteger SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalOutput_SetValue(phidgetId, index, value)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'sp 6/18/2009 21:03'!
primSetDoubleSensitivity: phidgetIdArray at: index to: value

	|floatSensitivity phidgetId|
	self primitive: 'primSetIndexedDoubleSensitivity' parameters: #(Oop SmallInteger Oop ).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatSensitivity type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatSensitivity := interpreterProxy floatValueOf: value.
	
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetComponent_SetIndexedDoubleSensitivity(phidgetId, index, floatSensitivity)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'sp 6/18/2009 16:58'!
primSetIntegerSensitivity: phidgetIdArray at: index to: value

	| phidgetId |
	self primitive: 'primSetIndexedIntegerSensitivity' parameters: #(Oop SmallInteger SmallInteger ).
	self var: #phidgetId type: 'PhidgetId'.

	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetComponent_SetIndexedIntegerSensitivity(phidgetId, index, value)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/29/2009 09:30'!
primSetMotorAcceleration: phidgetIdArray at: index to: acceleration

	| phidgetId floatAcceleration |
	self primitive: 'primSetMotorAcceleration' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatAcceleration := interpreterProxy floatValueOf: acceleration.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompMotor_SetAcceleration(phidgetId, index, floatAcceleration)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/29/2009 09:30'!
primSetMotorVelocity: phidgetIdArray at: index to: velocity

	| phidgetId floatVelocity |
	self primitive: 'primSetMotorVelocity' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatVelocity := interpreterProxy floatValueOf: velocity.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompMotor_SetVelocity(phidgetId, index, floatVelocity)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 20:26'!
primSetRFIDAntennaState: phidgetIdArray to: anInteger

	| phidgetId |
	self primitive: 'primSetRFIDAntennaState' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_SetAntennaState(phidgetId, anInteger)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/26/2009 06:39'!
primSetSemaphoreIndexAdvancedServoCurrentChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAdvancedServoCurrentChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetSemaphoreIndex_CurrentChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/26/2009 06:40'!
primSetSemaphoreIndexAdvancedServoVelocityChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAdvancedServoVelocityChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetSemaphoreIndex_VelocityChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Analog Sensor' stamp: 'sp 6/22/2009 11:58'!
primSetSemaphoreIndexAnalogSensorChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAnalogSensorChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAnalogSensor_SetSemaphoreIndex_ValueChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 12:45'!
primSetSemaphoreIndexAttach: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAttach' parameters: #(SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidget_SetSemaphoreIndex_Attach(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/22/2009 11:58'!
primSetSemaphoreIndexAxisChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAxisChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAxis_SetSemaphoreIndex_AccelerationChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 12:45'!
primSetSemaphoreIndexDetach: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexDetach' parameters: #(SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidget_SetSemaphoreIndex_Detach(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Input' stamp: 'sp 6/22/2009 12:00'!
primSetSemaphoreIndexDigitalInputChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexDigitalInputChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalInput_SetSemaphoreIndex_StateChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'sp 6/22/2009 12:02'!
primSetSemaphoreIndexDigitalOutputChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexDigitalOutputChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalOutput_SetSemaphoreIndex_StateChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 12:45'!
primSetSemaphoreIndexError: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexError' parameters: #(SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidget_SetSemaphoreIndex_Error(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/26/2009 06:29'!
primSetSemaphoreIndexMotorCurrentChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexMotorCurrentChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompMotor_SetSemaphoreIndex_CurrentChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/26/2009 06:29'!
primSetSemaphoreIndexMotorVelocityChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexMotorVelocityChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompMotor_SetSemaphoreIndex_VelocityChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 17:46'!
primSetSemaphoreIndexRFIDTagFound: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexRFIDTagFound' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_SetSemaphoreIndex_TagFound(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 17:46'!
primSetSemaphoreIndexRFIDTagLost: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexRFIDTagLost' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_SetSemaphoreIndex_TagLost(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:33'!
primSetSemaphoreIndexServoPositionChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexServoPositionChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_SetSemaphoreIndex_PositionChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'sp 6/29/2009 10:45'!
primSetServoEngaged: phidgetIdArray at: index to: state

	| phidgetId |
	self primitive: 'primSetServoEngaged' parameters: #(Oop SmallInteger SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_SetEngaged(phidgetId, index, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:34'!
primSetServoPosition: phidgetIdArray at: index to: position

	| phidgetId floatPosition |
	self primitive: 'primSetServoPosition' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatPosition := interpreterProxy floatValueOf: position.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_SetPosition(phidgetId, index, floatPosition)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Simple LED' stamp: 'lk 6/15/2009 20:38'!
primSetSimpleLEDState: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetSimpleLEDState' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompSimpleLED_SetState(phidgetId, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextDisplay' stamp: 'fs 7/5/2009 23:42'!
primSetTextDisplayCharacter: phidgetIdArray in: row and: column to: charStringArray

	| phidgetId character |
	self primitive: 'primSetTextDisplayCharacter' parameters: #(Oop SmallInteger SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #character type: 'char'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	
	(interpreterProxy stSizeOf: charStringArray) ~= 1 ifTrue: [ ^ nil ].
	character := ( self
		cCoerce: (interpreterProxy arrayValueOf: charStringArray)
		to: 'char*' ) at: 0.
	
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompTextLCD_DisplayCharacter(phidgetId, row, column, character)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextDisplay' stamp: 'fs 7/5/2009 22:23'!
primSetTextDisplayString: phidgetIdArray in: row to: stringArray

	| phidgetId string size |
	self primitive: 'primSetTextDisplayString' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #string type: 'char*'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	
	string := self cCoerce: (interpreterProxy arrayValueOf: stringArray) to: 'char*'.
	size := interpreterProxy stSizeOf: stringArray.
	
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompTextLCD_DisplayString(phidgetId, row, string, size)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:03'!
primSetTextLCDBacklightOn: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetTextLCDBacklightOn' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_SetBacklightOn(phidgetId, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:10'!
primSetTextLCDContrast: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetTextLCDContrast' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_SetContrast(phidgetId, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:36'!
primSetTextLCDCursorBlinking: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetTextLCDCursorBlinking' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_SetCursorBlinking(phidgetId, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget: TextLCD' stamp: 'fs 7/5/2009 18:40'!
primTextLCDCreate

	self primitive: 'primTextLCDCreate' parameters: #().
	^ self cCode: 'phidgetTextLCD_Create()'! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'lk 6/14/2009 18:14'!
shutdownModule
	"Shutdown the module"
	
	self export: true.
	self cCode: 'phidgetPlugin_Shutdown()'.
	^ 1! !

PolygonMorph subclass: #PhdLabWire
	instanceVariableNames: 'startpoint endpoint dragEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Lab'!

!PhdLabWire class methodsFor: 'as yet unclassified' stamp: 'sp 5/7/2009 22:00'!
from: startPoint to: endPoint

	^ (super new) initializeFrom: startPoint to: endPoint.! !

!PhdLabWire class methodsFor: 'as yet unclassified' stamp: 'sp 5/7/2009 22:06'!
new
	self error: 'Use ',self name, ' from: aPoint to: aPoint'.! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 23:41'!
acceptDroppingMorph: aMorph event: anEvent

	self stopStepping.! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/7/2009 13:09'!
endpoint

	^ endpoint! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 22:52'!
initializeFrom: startPoint to: endPoint

	self
		setVertices: {startPoint. endPoint};
		color: Color black;
		stopStepping.
	closed := false.! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 23:39'!
rejectDropMorphEvent: anEvent

	self delete.! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 22:46'!
setEndpoint: aPoint

	vertices at: vertices size put: aPoint.	
	endpoint := aPoint.
! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 22:43'!
setStartpoint: aPoint

	vertices at: 1 put: aPoint.
	startpoint := aPoint.! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/7/2009 13:08'!
startpoint

	^ startpoint! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 22:08'!
step
		"wire will be only created by dragging from a Morph to another one.
		 during this, the endpoint has to be changed to hand position"
		
		self setEndpoint: self currentWorld activeHand cursorPoint.! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 22:33'!
stepTime

	^ 100! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 23:56'!
wantsToBeDroppedInto: aMorph 
	"I want to be dropped onto a PhdLabConnector"

	^ (aMorph isKindOf: PhdLabConnector "&...")
! !

PartsBin subclass: #PhdETPartsBin
	instanceVariableNames: 'controlingMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

!PhdETPartsBin class methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 13:17'!
thumbnailForQuad: aQuint color: aColor phidget: aPhidget
	"Answer a thumbnail for a morph obtaining as per the quintuplet provided, creating the thumbnail if necessary.  If it is created afresh, it will also be cached at this time"

	| aThumbnail aSymbol formToThumbnail labeledItem |
	aSymbol := aQuint third.
	Thumbnails at: aSymbol ifPresent: [ :thumb | ^thumb ].
	formToThumbnail := aQuint at: 5 ifAbsent: [].
	formToThumbnail ifNil: [
		labeledItem := (Smalltalk at: aQuint first) perform: aQuint second with: aPhidget.
		formToThumbnail := labeledItem imageForm: 32 backgroundColor: aColor forRectangle: labeledItem fullBounds.
		formToThumbnail replaceColor: aColor withColor: Color transparent.
	].

	aThumbnail := Thumbnail new makeThumbnailFromForm: formToThumbnail.
	self cacheThumbnail: aThumbnail forSymbol: aSymbol.
	^ aThumbnail

"PartsBin initialize"! !

!PhdETPartsBin methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 11:47'!
controlingMorph
	^ controlingMorph! !

!PhdETPartsBin methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 11:48'!
controlingMorph: aMorph
	controlingMorph := aMorph.! !

!PhdETPartsBin methodsFor: 'as yet unclassified' stamp: 'pt 5/28/2009 13:20'!
listDirection: aListDirection quadList: quadList
	"Initialize the receiver to run horizontally or vertically, obtaining its elements from the list of tuples of the form:
		(<receiver> <selector> <label> <balloonHelp>)"

	| aButton aClass |
	self layoutPolicy: TableLayout new.
	self listDirection: aListDirection.
	self wrapCentering: #center.
	self layoutInset: 2.
	self cellPositioning: #bottomCenter.

	aListDirection == #leftToRight
		ifTrue:
			[self vResizing: #rigid.
			self hResizing: #spaceFill.
			self wrapDirection: #topToBottom]
		ifFalse:
			[self hResizing: #rigid.
			self vResizing: #spaceFill.
			self wrapDirection: #leftToRight].
	quadList do:
		[:tuple |
			aClass := Smalltalk at: tuple first.
			aButton := IconicButton new initializeWithThumbnail: (self class thumbnailForQuad: tuple color: self color phidget: self phidget) withLabel: tuple third andColor: self color andSend: tuple second to: aClass with: self phidget.
			(tuple size > 3 and: [tuple fourth isEmptyOrNil not]) ifTrue:
				[aButton setBalloonText: tuple fourth].
 			self addMorphBack: aButton]! !

!PhdETPartsBin methodsFor: 'as yet unclassified' stamp: 'pt 5/28/2009 17:11'!
phidget
	^ controlingMorph! !

RectangleMorph subclass: #PhdETBarMorph
	instanceVariableNames: 'min max value statusMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

!PhdETBarMorph methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 17:09'!
createAndAddStatusMorph

	statusMorph := BorderedMorph new
		borderWidth: 1;
		color: Color green muchLighter;
		yourself.
	self
		addMorph: statusMorph;
		updateStatus.! !

!PhdETBarMorph methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 17:07'!
initialize

	super initialize.
	min := 0.
	max := 1000.
	value := 0.
	self
		color: Color darkGray;
		createAndAddStatusMorph.! !

!PhdETBarMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 16:29'!
maxValue

	^ max! !

!PhdETBarMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 16:31'!
maxValue: aNumber

	max := aNumber.
	self updateStatus.! !

!PhdETBarMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 16:30'!
minValue

	^ min! !

!PhdETBarMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 16:31'!
minValue: aNumber

	min := aNumber.
	self updateStatus.! !

!PhdETBarMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 16:54'!
updateStatus
	
	| newWidth |
	max = min
		ifTrue: [ newWidth := 0 ]
		ifFalse: [ newWidth := self width asFloat * value asFloat / (max - min asFloat) -3].
	newWidth < 0 ifTrue: [ newWidth := 0 ].
	statusMorph
		position: self position + (1@1);
		height: self height - 2;
		width: newWidth.
	! !

!PhdETBarMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 16:30'!
value

	^ value! !

!PhdETBarMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 16:30'!
value: aNumber

	value := aNumber.
	self updateStatus.! !

!IconicButton methodsFor: '*Phidget-EToys' stamp: 'pt 5/7/2009 11:45'!
initializeWithThumbnail: aThumbnail withLabel: aLabel andColor: aColor andSend: aSelector to: aReceiver 	with: aPhidget
	"Initialize the receiver to show aThumbnail on its face, giving it the label supplied and arranging for it, when the button goes down on it, to obtain a new morph by sending the supplied selector to the supplied receiver"

	| labeledItem nonTranslucent |
	nonTranslucent := aColor asNontranslucentColor.
	labeledItem := AlignmentMorph newColumn.
	labeledItem color: nonTranslucent.
	labeledItem borderWidth: 0.
	labeledItem
		layoutInset: 4@0;
		cellPositioning: #center.
	labeledItem addMorph: aThumbnail.
	labeledItem addMorphBack: (Morph new extent: (4@4)) beTransparent.
	labeledItem addMorphBack: (TextMorph new
		backgroundColor: nonTranslucent;
		contentsAsIs: aLabel;
		beAllFont: Preferences standardEToysFont;
		centered).

	self
		beTransparent;
		labelGraphic: ((labeledItem imageForm: 32 backgroundColor: nonTranslucent forRectangle: labeledItem fullBounds) replaceColor: nonTranslucent withColor: Color transparent);
		borderWidth: 0;
		target: aReceiver;
		actionSelector: #launchPartVia:label:phidget:;
		arguments: {aSelector. aLabel. aPhidget};
		actWhen: #buttonDown.

	self stationarySetup.! !

TestCase subclass: #PhdCrInterfaceKitTest
	instanceVariableNames: 'ifKit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Tests'!

!PhdCrInterfaceKitTest methodsFor: 'testing' stamp: 'lk 5/28/2009 21:48'!
setUp
	"open an interface kit"
	
	ifKit := PhdCrInterfaceKit new openAny.! !

!PhdCrInterfaceKitTest methodsFor: 'testing' stamp: 'lk 5/28/2009 21:48'!
tearDown
	"close the interface kit"
	
	ifKit close.! !

!PhdCrInterfaceKitTest methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 12:09'!
testAttach
	"Test attaching an InterfaceKit"
	
	(PhidgetPluginTest questionWithoutCancel: 'Do you want to run the Test "Attach InterfaceKit"?')
		ifTrue: [
			self assert: (PhidgetPluginTest proceed: 'Now detach all InterfaceKits and press OK.').
			self deny: ifKit isAttached.
			self assert: (PhidgetPluginTest proceed: 'Now attach an InterfaceKit and press OK.').
			self assert: ifKit isAttached ].! !

!PhdCrInterfaceKitTest methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 21:56'!
testClose

	self assert: ifKit isOpen.
	ifKit close.
	self deny: ifKit isOpen.! !

!PhdCrInterfaceKitTest methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 21:54'!
testResetSemaphores
	"Test if after closing a Phidget all semaphores are reset."
	
	"use the PhdCrPhidget version of this test as we cannot access the handle from here."
	self assert: ifKit isOpen.
	self deny: ifKit testSemaphoresReset.
	ifKit close.
	self assert: ifKit testSemaphoresReset.! !

TestCase subclass: #PhidgetPluginTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Tests'!

!PhidgetPluginTest class methodsFor: 'dialogs' stamp: 'lk 5/31/2009 22:01'!
message: text
	"open a modal dialog window with the message in text and an OK Button.
	Return true if the user clicked 'OK', false otherwise."
	
	^ (Morph new openModal: 
		(MessageDialogWindow new
			textFont: Preferences standardDefaultTextFont;
			title: 'Running Phidget Tests';
			text: text)
		) cancelled not.! !

!PhidgetPluginTest class methodsFor: 'dialogs' stamp: 'lk 5/31/2009 22:01'!
proceed: text
	"open a modal dialog window with the message in text and a Cancel button.
	Return false if the user clicked 'Cancel', true otherwise."
	
	^ (Morph new openModal: 
		(ProceedDialogWindow new
			textFont: Preferences standardDefaultTextFont;
			title: 'Running Phidget Tests';
			text: text)
		) cancelled not.! !

!PhidgetPluginTest class methodsFor: 'dialogs' stamp: 'lk 5/31/2009 22:01'!
questionWithoutCancel: text
	"Show a modal dialog window asking the question is text and Buttons for Yes and No.
	Return true if the user clicked 'yes', false otherwise."
	
	^ (Morph new openModal: 
		(QuestionWithoutCancelDialogWindow new
			textFont: Preferences standardDefaultTextFont;
			title: 'Running Phidget Tests';
			text: text)
		) answer.! !

!PhidgetPluginTest methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 21:35'!
testTest

	"Hier soll ohne Vorbedingungen getestet werden wie getestet wird ;)"
	self assert: true.! !

!SequenceableCollection methodsFor: '*Phidget-Core' stamp: 'lk 6/16/2009 16:35'!
indexIsInRange: index
	"answer true if the given index is in range of this collection, false otherwise."

	^ index isInteger
		and: [ index >= 1 ]
		and: [ index <= self size ]! !

MixedCurveMorph subclass: #PhdETSegmentOfCircle
	instanceVariableNames: 'center radius angleA angleB'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

!PhdETSegmentOfCircle methodsFor: 'accessing' stamp: 'pt 6/3/2009 12:22'!
angleA

	^ angleA! !

!PhdETSegmentOfCircle methodsFor: 'accessing' stamp: 'pt 6/3/2009 12:26'!
angleA: anAngle
	"must be in degrees and between 0 and 360"
	( 0 <= anAngle and: [ anAngle <= 360 ] ) ifTrue: [
		angleA := anAngle.
		self updateShape ].! !

!PhdETSegmentOfCircle methodsFor: 'accessing' stamp: 'pt 6/3/2009 12:22'!
angleB

	^ angleB! !

!PhdETSegmentOfCircle methodsFor: 'accessing' stamp: 'pt 6/3/2009 12:26'!
angleB: anAngle
	"must be in degrees and between 0 and 360"
	( 0 <= anAngle and: [ anAngle <= 360 ] ) ifTrue: [
		angleB := anAngle.
		self updateShape ].! !

!PhdETSegmentOfCircle methodsFor: 'accessing' stamp: 'pt 6/3/2009 12:28'!
circleCenter

	^ center! !

!PhdETSegmentOfCircle methodsFor: 'accessing' stamp: 'pt 6/3/2009 12:28'!
circleCenter: aPoint

	center := aPoint.
	self updateShape.! !

!PhdETSegmentOfCircle methodsFor: 'initialization' stamp: 'pt 6/3/2009 17:23'!
initialize

	super initialize.
	center := 0@0.
	angleA := 0.
	angleB  := 0.
	radius := 1.
	slopeClamps := #(0 0 nil 0).
	self color: (Color black alpha: 0.5).
	self borderColor: Color transparent.
	self updateShape.! !

!PhdETSegmentOfCircle methodsFor: 'as yet unclassified' stamp: 'pt 6/3/2009 17:17'!
pointFromAngle: angle
	"Calculates the point of the cicrle belonging to an angle.
	angle must be in degrees (0<=angle<=360)"
	
	| x y |
	x := ( self servoRadians: angle ) cos * radius.
	y := ( self servoRadians: angle ) sin * radius.
	^ x@y! !

!PhdETSegmentOfCircle methodsFor: 'accessing' stamp: 'pt 6/3/2009 12:22'!
radius

	^ radius! !

!PhdETSegmentOfCircle methodsFor: 'accessing' stamp: 'pt 6/3/2009 12:26'!
radius: aNumber

	radius := aNumber.
	self updateShape.! !

!PhdETSegmentOfCircle methodsFor: 'as yet unclassified' stamp: 'pt 6/3/2009 17:16'!
servoRadians: aFloat
	| f |
	f := aFloat -90.0.
	(f<0) ifTrue: [ f := f + 360.0 ].
	^ f degreesToRadians! !

!PhdETSegmentOfCircle methodsFor: 'as yet unclassified' stamp: 'pt 6/3/2009 16:39'!
updateShape

	self setVertices: {	center.
								center + (self pointFromAngle: angleA).
								center + (self pointFromAngle: ( angleA + angleB / 2 )).
								center + (self pointFromAngle: angleB) }.! !

Object subclass: #PhdCrComponent
	instanceVariableNames: 'phidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrComponent commentStamp: 'lk 6/16/2009 16:45' prior: 0!
I am an abstract class for any Components a Phidget can have.


Instance Variables
	phidget:		<PhdCrPhidget>

phidget
	- the 'parent' of this component. Every component belongs to a Phidget. Only if the Phidget is attached the component is usable.
	- I need this value to invoke the primitives to talk with the plugin/Phidget hardware, because every primitive I know needs the Phidget's unique identifier (id).


I must be created with an instance of PhdCrPhidget as parameter that sets my 'phidget' instance variable (see 'class newWith:' and 'setParent').!

PhdCrComponent subclass: #PhdCrCompRFID
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompRFID commentStamp: 'lk 6/16/2009 19:45' prior: 0!
I am a special Phidget Component for reading RFID tags.
I have an antenna that can be enabled or disabled (getter/setter exist).
When my antenna is on I can read information about a near tag. Actually I only know which was the last tag I read, and whether I am currently reading any. The Phidget I belong to can signal when I found or lost a tag. (getter)

Currently I only belong to PhdCrRFID.
Example for usage there:
	rfid := PhdCrRFID new.
	rfid
		"The antenna might still be disabled, so enable it as soon as the Phidget is attached."
		on: #Attach do: [ rfid rfidSensor setAntennaState: true ];
		"Print to Transcript whenever we find or lose a tag. Print its identifier."
		on: #TagFound do: [ Transcript show: 'Tag found: ', rfid rfidSensor currentTag; cr ];
		on: #TagLost do: [ Transcript show: 'Tag lost: ', rfid rfidSensor lastTag; cr ];
		openAny.
	"Now attach a RFID Phidget, hold a tag near the Phidget and then take it away."
	rfid close.
!

!PhdCrCompRFID class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:51'!
primGetLastTag: phidgetIdArray
	"Answer a array of 5 bytes representing the id of the tag last read by this phidget, or nil if there was an error."

	<primitive: 'primGetLastRFIDTag' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompRFID class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:51'!
primHasTag: phidgetIdArray
	"Answer 1 if the Phidget currently reads a tag, or other values otherwise."
	
	<primitive: 'primHasRFIDTag' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompRFID class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:51'!
primIsAntennaOn: phidgetIdArray
	"Answer 1 if the antenna is on, or other values otherwise."
	
	<primitive: 'primIsRFIDAntennaOn' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompRFID class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:51'!
primSetAntennaState: phidgetIdArray to: state
	"Set the state of the antenna to on (state=1) or off (state=0).
	Return 1 if the operation succeeded, or other values otherwise."
	
	<primitive: 'primSetRFIDAntennaState' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompRFID class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:51'!
primSetSemaphoreIndexTagFound: semaphoreIndex for: phidgetIdArray
	"registers the given semaphore to be signaled when a tag is found by the given Phidget.
	Return 1 if the operation succeeded, other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexRFIDTagFound' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompRFID class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:51'!
primSetSemaphoreIndexTagLost: semaphoreIndex for: phidgetIdArray
	"registers the given semaphore to be signaled when a tag is lost by the given Phidget.
	Return 1 if the operation succeeded, other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexRFIDTagLost' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompRFID methodsFor: 'accessing' stamp: 'lk 6/16/2009 19:37'!
currentTag
	"Returns a string which represents a hex-value of the 5 bytes tag ID of the tag currently read.
	If there is no tag currently read, return an empty string."
	
	^ self hasTag
		ifTrue: [ self lastTag ]
		ifFalse: [ '' ]! !

!PhdCrCompRFID methodsFor: 'accessing' stamp: 'lk 6/15/2009 17:19'!
currentTagBytes
	"Returns a byte array with the 5 elements of the tag ID currently read.
	If there is no tag currently read, return nil."
	
	^ self hasTag
		ifTrue: [ self lastTagBytes ]
		ifFalse: [ nil ]! !

!PhdCrCompRFID methodsFor: 'accessing' stamp: 'lk 6/16/2009 19:34'!
hasTag
	"Returns true is a tag is currently read and false if not."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class primHasTag: phidget id) == 1! !

!PhdCrCompRFID methodsFor: 'accessing' stamp: 'lk 6/15/2009 17:25'!
isAntennaOn
	"Answer true if the antenna is on, false otherwise."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class primIsAntennaOn: phidget id) == 1! !

!PhdCrCompRFID methodsFor: 'accessing' stamp: 'lk 6/21/2009 12:13'!
isAntennaOn: aBoolean 
	"Sets the state of the antenna to true or false.
	The antenna must be enabled in order to find tags near the Phidget.
	Returns true if setting the antenna state was successful, false otherwise."
	
	| anInt |
	phidget isAttached ifFalse: [ ^ false ].
	aBoolean 
		ifTrue: [ anInt := 1 ]
		ifFalse: [ anInt := 0 ].
	^ (self class
		primSetAntennaState: phidget id
		to: anInt) == 1! !

!PhdCrCompRFID methodsFor: 'accessing' stamp: 'lk 6/16/2009 19:38'!
lastTag
	"Returns a string which represents a hex-value of the 5 bytes tag ID last read by the sensor.
	This tag may or may not still be on the reader.
	If there was no tag read by the reader since attached, the method returns a string with 10 zeros.
	If the Phidget with this component is not attached return an empty string."
	
	| aString bytes |
	aString := ''.
	bytes := self lastTagBytes.
	bytes ifNotNil: [
		bytes do: [ :byte | aString := aString , byte hex ] ].
	^ aString! !

!PhdCrCompRFID methodsFor: 'accessing' stamp: 'lk 6/16/2009 19:39'!
lastTagBytes
	"Returns a byte array with the 5 elements of the tag ID that was last read by the sensor.
	This tag may or may not still be on the reader.
	If there was no tag read by the reader since opened, the method returns a Byte array with zeros.
	If the Phidget is not attached return nil."
	
	phidget isAttached ifFalse: [ ^ nil ].
	^ self class primGetLastTag: phidget id! !

PhdCrComponent subclass: #PhdCrCompSimpleLED
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompSimpleLED commentStamp: 'lk 6/16/2009 19:46' prior: 0!
I am a special Phidget Component representing a simple LED.
I can be turned off or on (getter/setter exist).

Currently I only belong to PhdCrRFID.!

!PhdCrCompSimpleLED class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:51'!
primIsOn: phidgetIdArray
	"Answer 1 if theLED is on, or other values otherwise."
	
	<primitive: 'primIsSimpleLEDOn' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompSimpleLED class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:51'!
primSetState: phidgetIdArray to: state
	"Set the state of the LED to true (state=1) or false (state=0).
	Return 1 if the operation succeeded, other values otherwise."
	
	<primitive: 'primSetSimpleLEDState' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompSimpleLED methodsFor: 'accessing' stamp: 'lk 6/16/2009 19:41'!
isOn
	"Answer true if the phidget is attached and the LED is on, else false."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class primIsOn: phidget id) > 0! !

!PhdCrCompSimpleLED methodsFor: 'accessing' stamp: 'lk 6/21/2009 12:13'!
isOn: aBoolean 
	"Sets the state to true or false.
	true meens the LED is illuminated, false that it is not.
	returns true if setting was successful, and false otherwise."
	
	| anInt |
	phidget isAttached ifFalse: [ ^ false ].
	aBoolean 
		ifTrue: [ anInt := 1 ]
		ifFalse: [ anInt := 0 ].
	^ (self class
		primSetState: phidget id
		to: anInt) == 1! !

PhdCrComponent subclass: #PhdCrCompTextLCD
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrComponent class methodsFor: 'instance creation' stamp: 'lk 6/16/2009 20:19'!
newWith: phidget
	"create a new Component with given phidget. This Phidget, once set, will never change again."

	^ self new
		setParent: phidget! !

!PhdCrComponent methodsFor: 'accessing' stamp: 'lk 6/16/2009 20:35'!
on: aSymbol do: aBlock
	"When event aSymbol is signaled for my Phidget, do aBlock.
	This method is provided to have a moren natural interface.
	See PhdCrPhidget on:do: for more information."
	
	phidget on: aSymbol do: aBlock! !

!PhdCrComponent methodsFor: 'accessing' stamp: 'lk 6/1/2009 17:21'!
setParent: parent
	"Set my 'phidget' instance variable to the given one.
	If I already have a parent, do nothing."
	
	phidget ifNil: [ phidget := parent ].! !

PhdCrComponent subclass: #PhdCrMultiComponent
	instanceVariableNames: 'index nextLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrMultiComponent commentStamp: 'lk 6/16/2009 18:56' prior: 0!
I am an abstract Phidget Component for components that cann exist serveral times on a Phidget, but the exact number differs from Phidget to Phidget. (The Phidget type allows different numbers).


Instance Variables
	index:		<Integer>
	nextLink:	<nil or PhdCrMultiComponent>

index
	- number that identifies me on a Phidgets that has more instances of my class. Like 'parent' it is provided on construction and will never change again.
	- Needed on every primitve invocation, except for the primitive getting the number of equal components (componentCount).

nextLink
	- Needed to be member of a linked list. Can be ignored for Phidget understanding.


About MultiComponents:
	When a Phidget with a multi-component is attached, it initializes the list containing instances of this class. It uses my classes 'getListFor:' method to do this.
	'getListFor:' dynamically gets the number of similar components and adds one list item for each to the list. It calls 'primComponentCount:' to determine this number. This method must be overritten in subclasses to point to the right primitive.
	A MultiComponent is created by sending the 'newWith:index:' method to my class, because like in simple Components it needs a phidget 'parent', and for Multicomponents it aditionally needs its index (see above).
!

PhdCrMultiComponent subclass: #PhdCrCompAnalogSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompAnalogSensor commentStamp: 'sp 7/1/2009 14:39' prior: 0!
I am a special Phidget Component for analog sensor values.

I can be asked for a value I am currently reading, from 0 to 1000 (getter exists).

My Phidget can call a user defined callback block when my value changes, when prior
	analogSensor on: #SensorChange do: [ "user defined content" ]
was called. Note: This block will only be evaluated if the change of the value is equal or bigger than my changeTrigger.
My changeTrigger is a value between 0 and 100. (getter/setter exist).

Currently I only belong to PhdCrInterfaceKit.!

!PhdCrCompAnalogSensor class methodsFor: 'multi-component' stamp: 'lk 6/16/2009 20:55'!
primComponentCount: phidgetIdArray
	"Gets the number of sensors for a phidget analog sensors component."

	<primitive: 'primNumAnalogSensors' module: 'PhidgetPlugin'>
	^ 0! !

!PhdCrCompAnalogSensor class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:55'!
primGetSensitivity: phidgetIdArray at: index
	"Gets the current sensitivity of the given Phidget's sensor at given index."

	<primitive: 'primGetIntegerSensitivity' module: 'PhidgetPlugin'>
	^ 0! !

!PhdCrCompAnalogSensor class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:55'!
primGetValue: phidgetIdArray at: index
	"Gets the sensor value (0-1000) at the analog input with the given index."

	<primitive: 'primGetAnalogSensorValue' module: 'PhidgetPlugin'>
	^ 0! !

!PhdCrCompAnalogSensor class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:55'!
primSetSemaphoreIndexChange: semaphoreIndex for: phidgetIdArray
	"registers the given Semaphore to be signaled when an sensor value changes on the given Phidget.
	Return 1 if the operation succeeded, other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexAnalogSensorChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAnalogSensor class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:55'!
primSetSensitivity: phidgetIdArray at: index to: anInteger
	"Sets the sensitivity of given Phidget at given sensor index to the given value.
	Return 1 if the operation succeeded, other values otherwise."

	<primitive: 'primSetIntegerSensitivity' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAnalogSensor methodsFor: 'accessing' stamp: 'lk 6/26/2009 11:05'!
changeTrigger

	phidget isAttached ifFalse: [ ^ 0 ].
	^ self class
		primGetSensitivity: phidget id
		at: index - 1! !

!PhdCrCompAnalogSensor methodsFor: 'accessing' stamp: 'lk 6/26/2009 11:05'!
changeTrigger: anInteger
	"Sets the sensor change trigger of the sensor to 'anInteger'.
	a sensor change block will only be evaluated if the change is more than this trigger."
	
	phidget isAttached ifFalse: [ ^ false ].
	(anInteger isInRange: (0 to: 100)) ifFalse: [ ^ false ].

	^ (self class
		primSetSensitivity: phidget id
		at: index - 1
		to: anInteger) == 1! !

!PhdCrCompAnalogSensor methodsFor: 'accessing' stamp: 'lk 6/15/2009 21:53'!
value
	"Gets the current value of the sensor (integer from 0 to 1000)."
	
	phidget isAttached ifFalse: [ ^ 0 ].
	^ self class
		primGetValue: phidget id
		at: index - 1! !

PhdCrMultiComponent subclass: #PhdCrCompAxis
	instanceVariableNames: 'sensitivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompAxis commentStamp: 'sp 7/1/2009 14:38' prior: 0!
I am a special Phidget Component for axes.

I can be asked for the current acceleration of an axis of me, which can be retrieved and set (getter/setter exist). This acceleration should be between my minimal and maximal position which can also be retrieved. Be careful that if those values cannot be retrieved (for instance if the Phidget is not attached) they return a value of 0.0, although this may also be a valid value.

My Phidget can call a user defined callback block when my acceleration changes, when prior
	axis on: #AccelerationChange do: [ "user defined content" ]
was called. Note: This block will only be evaluated if the change of the value is equal or bigger than my changeTrigger.
My changeTrigger is a value between 0 and 1 (getter/setter exist).
By default it is set to 0.05, so that there will be no acceleration when I am not in move.

Currently I only belong to PhdCrAccelerometer.!

!PhdCrCompAxis class methodsFor: 'multi-component' stamp: 'sp 6/18/2009 21:59'!
primComponentCount: phidgetHandle
	"Gets the number of axes for a phidget axis component."

	<primitive: 'primNumAxes' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAxis class methodsFor: 'primitives' stamp: 'sp 6/24/2009 14:35'!
primGetAcceleration: phidgetHandle at: index
	"Gets the acceleration of the given axis."

	<primitive: 'primGetAxisAcceleration' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAxis class methodsFor: 'primitives' stamp: 'sp 6/21/2009 10:15'!
primGetMaxAcceleration: phidgetIdArray at: index
	"Returns a float containing max. possible acceleration of the axis at the given index."

	<primitive: 'primGetAxisAccelerationMax' module: 'PhidgetPlugin'>
	^ 0.0! !

!PhdCrCompAxis class methodsFor: 'primitives' stamp: 'sp 6/21/2009 10:15'!
primGetMinAcceleration: phidgetIdArray at: index
	"Returns a float containing min. possible acceleration of the axis at the given index."

	<primitive: 'primGetAxisAccelerationMin' module: 'PhidgetPlugin'>
	^ 0.0! !

!PhdCrCompAxis class methodsFor: 'primitives' stamp: 'sp 6/19/2009 09:25'!
primGetSensitivity: phidgetHandle at: index

	<primitive: 'primGetIndexedDoubleSensitivity' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAxis class methodsFor: 'primitives' stamp: 'sp 6/18/2009 21:30'!
primSetSemaphoreIndexChange: semaphoreIndex for: phidgetIdArray
	"registers the given Semaphore to be signaled when an acceleration occurs on the given Phidget.
	Return 1 if the operation succeeded, other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexAxisChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAxis class methodsFor: 'primitives' stamp: 'sp 6/19/2009 09:26'!
primSetSensitivity: phidgetHandle at: index to: anInteger

	<primitive: 'primSetIndexedDoubleSensitivity' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAxis methodsFor: 'accessing' stamp: 'lk 6/26/2009 11:12'!
acceleration
	"Gets the current raw acceleration of the axis (double between min and max), multiplied by self sensitivity."
	
	^ self accelerationRaw * self sensitivity! !

!PhdCrCompAxis methodsFor: 'accessing' stamp: 'sp 6/24/2009 14:32'!
accelerationMax
	"Gets the max. acceleration of the axis.
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetAccelerationMax: phidget id
		at: index - 1! !

!PhdCrCompAxis methodsFor: 'accessing' stamp: 'sp 6/24/2009 14:32'!
accelerationMin
	"Gets the min. acceleration of the axis.
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetAccelerationMin: phidget id
		at: index - 1! !

!PhdCrCompAxis methodsFor: 'accessing' stamp: 'lk 6/26/2009 11:11'!
accelerationRaw
	"Gets the current acceleration of the axis (double between min and max).
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetAcceleration: phidget id
		at: index - 1! !

!PhdCrCompAxis methodsFor: 'accessing' stamp: 'pt 6/23/2009 18:44'!
angleDegrees

	^ self angleRadians radiansToDegrees! !

!PhdCrCompAxis methodsFor: 'accessing' stamp: 'pt 6/23/2009 19:08'!
angleDegreesNumber 

	^ self angleDegrees + 90.0 / 180.0 * 1000.0! !

!PhdCrCompAxis methodsFor: 'accessing' stamp: 'lk 6/26/2009 11:10'!
angleRadians

	| normalized |
	normalized := self acceleration.
	normalized < -1.0 ifTrue: [ normalized := -1.0 ].
	normalized > 1.0 ifTrue: [ normalized := 1.0 ].
	
	^ normalized arcSin! !

!PhdCrCompAxis methodsFor: 'accessing' stamp: 'lk 6/25/2009 13:22'!
changeTrigger
	"Gets the current change trigger of the axis (double between 0.0 and 1.0).
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetSensitivity: phidget id
		at: index - 1! !

!PhdCrCompAxis methodsFor: 'accessing' stamp: 'lk 6/25/2009 13:22'!
changeTrigger: aDouble
	"Sets the acceleration change trigger of the axis to 'aDouble'.
	a acceleration change block will only be evaluated if the change is more than this trigger.
	Return true if the operation succeeds, false otherwise."
	
	| value |
	phidget isAttached ifFalse: [ ^ false ].
	value := aDouble asFloat.
	( value >= 0.0 and: [ value <= 1.0 ] ) ifFalse: [ ^ false ].

	^ (self class
		primSetSensitivity: phidget id
		at: index - 1
		to: value) == 1! !

!PhdCrCompAxis methodsFor: 'accessing' stamp: 'lk 6/25/2009 13:26'!
sensitivity
	sensitivity ifNil: [ sensitivity := 1.0 ].
	^ sensitivity! !

!PhdCrCompAxis methodsFor: 'accessing' stamp: 'lk 6/25/2009 13:27'!
sensitivity: aNumber
	sensitivity := aNumber.! !

PhdCrMultiComponent subclass: #PhdCrCompDigitalInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompDigitalInput commentStamp: 'sp 7/1/2009 14:39' prior: 0!
I am a special Phidget Component for digital input values.

I can be asked for a value I am currently reading, either true or false (getter exists). True means there is a current I can read, false there is not.

My Phidget can call a user defined callback block when my value changes, when prior
	digitalInput on: #InputChange do: [ "user defined content" ]
was called.

Currently I belong to 
	- PhdCrInterfaceKit
	- PhdCrMotorControl.!

!PhdCrCompDigitalInput class methodsFor: 'multi-component' stamp: 'lk 6/16/2009 20:56'!
primComponentCount: phidgetIdArray
	"Gets the number of inputs for a phidget digital input component."

	<primitive: 'primNumDigitalInputs' module: 'PhidgetPlugin'>
	^ 0! !

!PhdCrCompDigitalInput class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:56'!
primGetValue: phidgetIdArray at: index
	"Gets the input value (0/1 = off/on) at the digital input with the given index."

	<primitive: 'primGetDigitalInputValue' module: 'PhidgetPlugin'>
	^ 0! !

!PhdCrCompDigitalInput class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:56'!
primSetSemaphoreIndexChange: semaphoreIndex for: phidgetIdArray
	"registers the given Semaphore to be signaled when an input value changes on the given Phidget.
	Return 1 if the operation succeeded, other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexDigitalInputChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalInput methodsFor: 'accessing' stamp: 'lk 6/16/2009 19:53'!
value
	"Gets the current value of the input (true/false = on/off)."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class
		primGetValue: phidget id
		at: index - 1) == 1! !

PhdCrMultiComponent subclass: #PhdCrCompDigitalOutput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompDigitalOutput commentStamp: 'sp 7/1/2009 14:39' prior: 0!
I am a special Phidget Component for digital output values.

I can be asked for or set a value I am currently having, either true or false (getter/setter exist). True means there is a current at this output, false that there is not.

My Phidget can call a user defined callback block when my value changes, when prior
	digitalOutput on: #OutputChange do: [ "user defined content" ]
was called.

Currently I can belong to
	- PhdCrInterfaceKit
	- PhdCrRFID!

!PhdCrCompDigitalOutput class methodsFor: 'multi-component' stamp: 'lk 6/16/2009 20:56'!
primComponentCount: phidgetIdArray
	"Gets the number of outputs for a phidget digital output component."

	<primitive: 'primNumDigitalOutputs' module: 'PhidgetPlugin'>
	^ 0! !

!PhdCrCompDigitalOutput class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:56'!
primGetValue: phidgetIdArray at: index
	"Gets the output value (0/1 = off/on) at the digital output with the given index."

	<primitive: 'primGetDigitalOutputValue' module: 'PhidgetPlugin'>
	^ 0! !

!PhdCrCompDigitalOutput class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:56'!
primSetSemaphoreIndexChange: semaphoreIndex for: phidgetIdArray
	"registers the given Semaphore to be signaled when an output value changes on the given Phidget.
	Return 1 if the operation succeeded, other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexDigitalOutputChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalOutput class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:56'!
primSetValue: phidgetIdArray at: index to: value
	"Sets the output value (0/1 = off/on) at the digital output with the given index to the given value.
	Return 1 if the operation succeeded, other values otherwise."

	<primitive: 'primSetDigitalOutputValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalOutput methodsFor: 'accessing' stamp: 'lk 6/16/2009 19:55'!
value
	"Gets the current value of the output (true/false = on/off)."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class
		primGetValue: phidget id
		at: index - 1) == 1! !

!PhdCrCompDigitalOutput methodsFor: 'accessing' stamp: 'lk 6/16/2009 19:55'!
value: aBoolean
	"Sets the current value of the output (true = on, false = off).
	Returns true if the value was sucessfully set, false otherwise."
	
	| number |
	phidget isAttached ifFalse: [ ^ false ].
	aBoolean
		ifTrue: [ number := 1 ]
		ifFalse: [ number := 0 ].
	^ (self class
		primSetValue: phidget id
		at: index - 1
		to: number) == 1! !

PhdCrMultiComponent subclass: #PhdCrCompMotor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompMotor commentStamp: 'sp 7/1/2009 16:10' prior: 0!
I am a special Phidget Component for advanced servo motors.

I have a current acceleration, which can be retrieved and set (getter/setter exist). This acceleration should be between my minimal and maximal acceleration which can also be retrieved. Be careful that if those values cannot be retrieved (for instance if the Phidget is not attached) they return a value of 0.0, although this may also be a valid value.
In addition I have a current velocity, which can be retrieved and set (getter/setter exist). This velocity should be between -100.0 to 100.0. Setting other values will have no effect but returning false.
I also can be asked for my current current draw.

My Phidget can call a user defined callback block when my motor velocity changes, when prior
	motorControl on: #VelocityChange do: [ "user defined content" ]
was called.
It also can call a user defined callback block when the current draw of my motor changes, when prior
	motorControl on: #CurrentChange do: [ "user defined content" ]
was called.

Currently I only belong to PhdCrMotorControl.!

!PhdCrCompMotor class methodsFor: 'multi-component' stamp: 'sp 6/24/2009 14:29'!
primComponentCount: phidgetHandle
	"Gets the number of motors for a phidget motor component."

	<primitive: 'primNumMotors' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompMotor class methodsFor: 'primitives' stamp: 'sp 6/24/2009 14:36'!
primGetAcceleration: phidgetHandle at: index
	"Gets the acceleration of the given motor."

	<primitive: 'primGetMotorAcceleration' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompMotor class methodsFor: 'primitives' stamp: 'sp 7/1/2009 16:17'!
primGetAccelerationMax: phidgetHandle at: index
	"Returns a float containing max. possible acceleration of the motor at the given index."

	<primitive: 'primGetMotorAccelerationMax' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompMotor class methodsFor: 'primitives' stamp: 'sp 7/1/2009 16:17'!
primGetAccelerationMin: phidgetHandle at: index
	"Returns a float containing min. possible acceleration of the motor at the given index."

	<primitive: 'primGetMotorAccelerationMin' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompMotor class methodsFor: 'primitives' stamp: 'sp 7/1/2009 16:18'!
primGetCurrent: phidgetHandle at: index
	"Gets the current of the given motor."

	<primitive: 'primGetMotorCurrent' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompMotor class methodsFor: 'primitives' stamp: 'sp 6/24/2009 14:48'!
primGetVelocity: phidgetHandle at: index
	"Gets the velocity of the given motor."

	<primitive: 'primGetMotorVelocity' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompMotor class methodsFor: 'primitives' stamp: 'sp 6/24/2009 14:37'!
primSetAcceleration: phidgetIdArray at: index to: aFloat
	"Set the acceleration of the motor at the given index to aFloat. aFloat must be between primGetAccelerationMin and primGetAccelerationMax.
	Return 1 if the operation succeeded, other values otherwise."

	<primitive: 'primSetMotorAcceleration' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 06:29'!
primSetSemaphoreIndexCurrentChange: semaphoreIndex for: phidgetIdArray
	"registers the given Semaphore to be signaled when the current draw changes on the given Phidget.
	Return 1 if the operation succeeded, other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexMotorCurrentChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 06:29'!
primSetSemaphoreIndexVelocityChange: semaphoreIndex for: phidgetIdArray
	"registers the given Semaphore to be signaled when the velocity changes on the given Phidget.
	Return 1 if the operation succeeded, other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexMotorVelocityChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompMotor class methodsFor: 'primitives' stamp: 'sp 7/1/2009 16:36'!
primSetVelocity: phidgetIdArray at: index to: aFloat
	"Set the velocity of the motor at the given index to aFloat. (For succeed: aFloat has to be in Range of -100.0 and 100.0)
	Return 1 if the operation succeeded, other values otherwise."

	<primitive: 'primSetMotorVelocity' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompMotor methodsFor: 'accessing' stamp: 'sp 6/24/2009 14:33'!
acceleration
	"Gets the current acceleration of the motor (double between min and max).
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetAcceleration: phidget id
		at: index - 1! !

!PhdCrCompMotor methodsFor: 'accessing' stamp: 'sp 6/25/2009 21:45'!
acceleration: aValue
	"Set the acceleration of the motor.
	aValue should be a number betwenn self accelerationMin and self accelerationMax (inclusivly).
	Returns true if the setting was successful, false otherwise."
	
	| aFloat |
	phidget isAttached ifFalse: [ ^ false ].
	aFloat := aValue asFloat.
	(self accelerationIsInRange: aFloat) ifFalse: [ ^ false ].
	^ (self class
		primSetAcceleration: phidget id
		at: index - 1
		to: aFloat) == 1! !

!PhdCrCompMotor methodsFor: 'accessing' stamp: 'sp 7/1/2009 16:21'!
accelerationIsInRange: acceleration
	"Return true if the acceleration is in range of this motor, false otherwise.
	The acceleration is in range if the Phidget is attached and the acceleration is between the min. and max. acceleration."
	
	phidget isAttached ifFalse: [ ^ false ].
	self accelerationMin <= acceleration ifFalse: [ ^ false ].
	self accelerationMax >= acceleration ifFalse: [ ^ false ].
	^ true! !

!PhdCrCompMotor methodsFor: 'accessing' stamp: 'sp 6/24/2009 14:34'!
accelerationMax
	"Gets the max. acceleration supported by a motor
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetAccelerationMax: phidget id
		at: index - 1! !

!PhdCrCompMotor methodsFor: 'accessing' stamp: 'sp 6/24/2009 14:33'!
accelerationMin
	"Gets the min. acceleration supported by a motor
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetAccelerationMin: phidget id
		at: index - 1! !

!PhdCrCompMotor methodsFor: 'accessing' stamp: 'sp 6/24/2009 14:47'!
current
	"Gets the current current draw for a motor. 
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetCurrent: phidget id
		at: index - 1! !

!PhdCrCompMotor methodsFor: 'accessing' stamp: 'sp 6/24/2009 14:40'!
velocity
	"Gets the current velocity of the motor.
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetVelocity: phidget id
		at: index - 1! !

!PhdCrCompMotor methodsFor: 'accessing' stamp: 'sp 7/1/2009 16:34'!
velocity: aValue
	"Set the velocity of the motor. aValue should be in Range of -100.0 and 100.0.
	Returns true if the setting was successful, false otherwise."
	
	| aFloat |
	phidget isAttached ifFalse: [ ^ false ].
	aFloat := aValue asFloat.
	^ (self class
		primSetVelocity: phidget id
		at: index - 1
		to: aFloat) == 1! !

PhdCrMultiComponent subclass: #PhdCrCompServoMotor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompServoMotor commentStamp: 'sp 7/1/2009 14:40' prior: 0!
I am a special Phidget Component for simple servo motors.

I have a current position, which can be retrieved and set (getter/setter exist). This position should be between my minimal and maximal position which can also be retrieved. Be careful that if those values cannot be retrieved (for instance if the Phidget is not attached) they return a value of 0.0, although this may also be a valid value.
My motor is automatically engaged when a new position is set. The boolean value whether it is engaged or not can be retrieved and set.

My Phidget can call a user defined callback block when my motor position changes, when prior
	servoMotor on: #PositionChange do: [ "user defined content" ]
was called.

Currently I only belong to PhdCrServo.!

PhdCrCompServoMotor subclass: #PhdCrCompAdvancedServoMotor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompAdvancedServoMotor commentStamp: 'sp 7/1/2009 16:02' prior: 0!
I am a special Phidget Component for advanced servo motors.

Like my super class I have a current position and my motor is engaged when a new position is set (see my super class' documentation for more information). Additionally I am able to limitate the min. and max. position of a motor.
I have a current velocity and acceleration, which can be retrieved and set (getter/setter exist). This velocity (or acceleration) should be between my minimal and maximal velocity (or acceleration) which can also be retrieved. Be careful that if those values cannot be retrieved (for instance if the Phidget is not attached) they return a value of 0.0, although this may also be a valid value. Furthermore I'm able to limitate the min. and max. velocity of a motor.
I also can be asked for my current current draw and whether I'm stopped or not.
In isSpinningAccelerated can be set whether I should keep attention on acceleration and velocity or not.

My Phidget can call a user defined callback block when my motor velocity changes, when prior
	advServoMotor on: #VelocityChange do: [ "user defined content" ]
was called.
It also can call a user defined callback block when the current draw of my motor changes, when prior
	advServoMotor on: #CurrentChange do: [ "user defined content" ]
was called.

Currently I only belong to PhdCrAdvancedServo.!

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:27'!
primGetAcceleration: phidgetHandle at: index
	"Gets the acceleration of the given motor."

	<primitive: 'primGetAdvancedServoAcceleration' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:27'!
primGetAccelerationMax: phidgetHandle at: index
	"Gets the max. acceleration of the given motor."

	<primitive: 'primGetAdvancedServoAccelerationMax' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:27'!
primGetAccelerationMin: phidgetHandle at: index
	"Gets the min. acceleration of the given motor."

	<primitive: 'primGetAdvancedServoAccelerationMin' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:27'!
primGetCurrent: phidgetHandle at: index
	"Gets the current of the given motor."

	<primitive: 'primGetAdvancedServoCurrent' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:27'!
primGetVelocity: phidgetHandle at: index
	"Gets the velocity of the given motor."

	<primitive: 'primGetAdvancedServoVelocity' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:27'!
primGetVelocityLimit: phidgetHandle at: index
	"Gets the limit of the velocity of the given motor."

	<primitive: 'primGetAdvancedServoVelocityLimit' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:27'!
primGetVelocityMax: phidgetHandle at: index
	"Gets the max. velocity of the given motor."

	<primitive: 'primGetAdvancedServoVelocityMax' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:27'!
primGetVelocityMin: phidgetHandle at: index
	"Gets the min. velocity of the given motor."

	<primitive: 'primGetAdvancedServoVelocityMin' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:51'!
primIsSpeedRampingOn: phidgetIdArray at: index
	"Returns 1 if the motor on the given index is using acceleration and velocity, or other values otherwise."

	<primitive: 'primIsAdvancedServoSpeedRampingOn' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 18:15'!
primIsStopped: phidgetIdArray at: index
	"Returns 1 if the motor on the given index is stopped and that there are no commands in the pipeline
to the servo, or other values otherwise."

	<primitive: 'primIsAdvancedServoStopped' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:28'!
primSetAcceleration: phidgetIdArray at: index to: aFloat
	"Set the acceleration of the motor at the given index to aFloat. aFloat must be between primGetAccelerationMin and primGetAccelerationMax.
	Return 1 if the operation succeeded, other values otherwise."

	<primitive: 'primSetAdvancedServoAcceleration' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:28'!
primSetPositionMax: phidgetHandle at: index
	"Sets the max. position of the given motor."

	<primitive: 'primGetAdvancedServoPositionMax' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:28'!
primSetPositionMin: phidgetHandle at: index
	"Sets the min. position of the given motor."

	<primitive: 'primGetAdvancedServoPositionMin' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 06:35'!
primSetSemaphoreIndexCurrentChange: semaphoreIndex for: phidgetIdArray
	"registers the given Semaphore to be signaled when the current draw changes on the given Phidget.
	Return 1 if the operation succeeded, other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexAdvancedServoCurrentChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 06:35'!
primSetSemaphoreIndexVelocityChange: semaphoreIndex for: phidgetIdArray
	"registers the given Semaphore to be signaled when the velocity changes on the given Phidget.
	Return 1 if the operation succeeded, other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexAdvancedServoVelocityChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 7/1/2009 16:31'!
primSetSpeedRampingOn: phidgetIdArray at: index to: value
	"Sets whether acceleration and velocity of the motor at the given index are used or not.
	Return 1 if the operation succeeded, other values otherwise."

	<primitive: 'primSetAdvancedServoSpeedRampingOn' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 7/1/2009 16:38'!
primSetVelocity: phidgetIdArray at: index to: aFloat
	"Set the velocity of the motor at the given index to aFloat. aFloat must be between primGetVelocityMin and primGetVelocityMax.
	Return 1 if the operation succeeded, other values otherwise."

	<primitive: 'primSetAdvancedServoVelocity' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor class methodsFor: 'primitives' stamp: 'sp 6/26/2009 17:28'!
primSetVelocityLimit: phidgetIdArray at: index to: aFloat
	"Set the limit of the velocity of the motor at the given index to aFloat. aFloat must be between primGetVelocityMin and primGetVelocityMax.
	Return 1 if the operation succeeded, other values otherwise."

	<primitive: 'primSetAdvancedServoVelocityLimit' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 6/26/2009 17:20'!
acceleration
	"Gets the current acceleration of the motor (double between min and max).
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetAcceleration: phidget id
		at: index - 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 6/26/2009 17:20'!
acceleration: aValue
	"Set the acceleration of the motor.
	aValue should be a number betwenn self accelerationMin and self accelerationMax (inclusivly).
	Returns true if the setting was successful, false otherwise."
	
	| aFloat |
	phidget isAttached ifFalse: [ ^ false ].
	aFloat := aValue asFloat.
	(self accelerationIsInRange: aFloat) ifFalse: [ ^ false ].
	^ (self class
		primSetAcceleration: phidget id
		at: index - 1
		to: aFloat) == 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 6/26/2009 16:30'!
accelerationIsInRange: acceleration
	"Return true if the acceleration is in range of this motor, false otherwise.
	The acceleration is in range if the Phidget is attached and the acceleration is between the min. and max. acceleration."
	
	phidget isAttached ifFalse: [ ^ false ].
	self accelerationMin <= acceleration ifFalse: [ ^ false ].
	self accelerationMax >= acceleration ifFalse: [ ^ false ].
	^ true! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 6/26/2009 17:20'!
accelerationMax
	"Gets the max. acceleration supported by a motor
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetAccelerationMax: phidget id
		at: index - 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 6/26/2009 17:21'!
accelerationMin
	"Gets the min. acceleration supported by a motor
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetAccelerationMin: phidget id
		at: index - 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 6/26/2009 17:22'!
current
	"Gets the current current draw for a motor. 
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetCurrent: phidget id
		at: index - 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 7/1/2009 15:48'!
isSpinningAccelerated
	"Returns the speed ramping state of the motor. This is whether or not velocity and acceleration are used."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class
		primIsSpeedRampingOn: phidget id
		at: index - 1) == 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 7/1/2009 15:48'!
isSpinningAccelerated: aBoolean
	"Sets the speed ramping state of a motor. This is whether or not velocity and acceleration are used.
	Returns true if the setting was successful, false otherwise."
	
	| anInt |
	phidget isAttached ifFalse: [ ^ false ].
	aBoolean 
		ifTrue: [ anInt := 1 ]
		ifFalse: [ anInt := 0 ].
	^ (self class
		primSetSpeedRampingOn: phidget id
		at: index - 1
		to: anInt) == 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 6/26/2009 18:18'!
isStopped
	"Returns the motion state of the motor. This is whether the motor has stopped or not."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class
		primIsStopped: phidget id
		at: index - 1) == 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 7/1/2009 17:04'!
positionIsInRange: position
	"Return true if the position is in range of this motor, false otherwise.
	The position is in range if the Phidget is attached and the position is between the original min. and max. position."
	
	phidget isAttached ifFalse: [ ^ false ].
	( -22.9921875 <= position and: [ 233.0 >= position ]) ifFalse: [ ^ false ].
	^ true! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 6/26/2009 17:15'!
positionMax: aValue
	"Sets the max. allowed position of the motor (double between min and max).
	Returns true if the setting was successful, false otherwise."
	
	| aFloat |
	phidget isAttached ifFalse: [ ^ false ].
	aFloat := aValue asFloat.
	(self positionIsInRange: aFloat) ifFalse:[ ^ false ].
	^( self class
		primSetPostionMax: phidget id
		at: index - 1 
		to: aFloat) == 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 7/1/2009 16:46'!
positionMin: aValue
	"Sets the min. allowed position of the motor (double between original min and max).
	Returns true if the setting was successful, false otherwise."
	
	| aFloat |
	phidget isAttached ifFalse: [ ^ false ].
	aFloat := aValue asFloat.
	(self positionIsInRange: aFloat) ifFalse:[ ^ false ].
	^( self class
		primSetPostionMin: phidget id
		at: index - 1 
		to: aFloat) == 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 6/26/2009 16:38'!
velocity
	"Gets the velocity of the motor (double between min and max with regard to the limit).
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetVelocity: phidget id
		at: index - 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 6/26/2009 16:30'!
velocityIsInRange: velocity
	"Return true if the velocity is in range of this motor, false otherwise.
	The velocity is in range if the Phidget is attached and the velocity is between the min. and max. velocity."
	
	phidget isAttached ifFalse: [ ^ false ].
	self velocityMin <= velocity ifFalse: [ ^ false ].
	self velocityMax >= velocity ifFalse: [ ^ false ].
	^ true! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 7/1/2009 16:54'!
velocityLimit
	"Gets the limited velocity of the motor (double between min and max).
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetVelocityLimit: phidget id
		at: index - 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 7/1/2009 16:56'!
velocityLimit: aValue
	"Sets the limit of the velocity of the motor (double between min and max).
	if there was an error, return flase"
	
	| aFloat |
	phidget isAttached ifFalse: [ ^ false ].
	aFloat := aValue asFloat.
	(self velocityIsInRange: aFloat) ifFalse:[ ^ false ].
	^( self class
		primSetVelocityLimit: phidget id
		at: index - 1 
		to: aFloat) == 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 6/26/2009 16:39'!
velocityMax
	"Gets the max. velocity supported by a motor.
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetVelocityMax: phidget id
		at: index - 1! !

!PhdCrCompAdvancedServoMotor methodsFor: 'accessing' stamp: 'sp 6/26/2009 16:39'!
velocityMin
	"Gets the min. velocity supported by a motor.
	if there was an error, return 0.0"
	
	phidget isAttached ifFalse: [ ^ 0.0 ].
	^ self class
		primGetVelocityMin: phidget id
		at: index - 1! !

!PhdCrCompServoMotor class methodsFor: 'multi-component' stamp: 'lk 6/16/2009 20:56'!
primComponentCount: phidgetIdArray
	"Gets the number of servo motors for a (simple) servo motor component."

	<primitive: 'primNumServoMotors' module: 'PhidgetPlugin'>
	^ 0! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:56'!
primGetMaxPosition: phidgetIdArray at: index
	"Returns a float containing max. possible position of the motor at the given index."

	<primitive: 'primGetServoPositionMax' module: 'PhidgetPlugin'>
	^ 0.0! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:56'!
primGetMinPosition: phidgetIdArray at: index
	"Returns a float containing min. possible position of the motor at the given index."

	<primitive: 'primGetServoPositionMin' module: 'PhidgetPlugin'>
	^ 0.0! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:56'!
primGetPosition: phidgetIdArray at: index
	"Returns a float containing the position of the motor at the given index."

	<primitive: 'primGetServoPosition' module: 'PhidgetPlugin'>
	^ 0.0! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:57'!
primIsEngaged: phidgetIdArray at: index
	"Returns 1 if the motor on the given index is engaged, or other values otherwise."

	<primitive: 'primIsServoEngaged' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:57'!
primSetEngaged: phidgetIdArray at: index to: value
	"Sets the engagement state (0/1 = off/on) of the motor at the given index.
	Return 1 if the operation succeeded, other values otherwise."

	<primitive: 'primSetServoEngaged' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:57'!
primSetPosition: phidgetIdArray at: index to: aFloat
	"Set the position of the motor at the given index to aFloat. aFloat must be between primGetPositionMin and primGetPositionMax.
	Return 1 if the operation succeeded, other values otherwise."

	<primitive: 'primSetServoPosition' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/16/2009 20:57'!
primSetSemaphoreIndexPositionChange: semaphoreIndex for: phidgetIdArray
	"registers the given Semaphore to be signaled when a motor changes its position.
	Return 1 if the operation succeeded, other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexServoPositionChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompServoMotor methodsFor: 'accessing' stamp: 'lk 6/16/2009 15:10'!
isEngaged
	"Returns the engaged state of the motor. This is whether the motor is powered or not."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class
		primIsEngaged: phidget id
		at: index - 1) == 1! !

!PhdCrCompServoMotor methodsFor: 'accessing' stamp: 'lk 6/21/2009 12:12'!
isEngaged: aBoolean
	"Sets the engaged state of a motor. This is whether the motor is powered or not.
	Returns true if the setting was successful, false otherwise."
	
	| anInt |
	phidget isAttached ifFalse: [ ^ false ].
	aBoolean 
		ifTrue: [ anInt := 1 ]
		ifFalse: [ anInt := 0 ].
	^ (self class
		primSetEngaged: phidget id
		at: index - 1
		to: anInt) == 1! !

!PhdCrCompServoMotor methodsFor: 'accessing' stamp: 'lk 6/16/2009 20:10'!
position
	"Returns the current position of the motor as a floating point number.
	This value is between self positinMin and self positionMax.
	If it cannot be retrieved it is 0.0 (although this may also be a valid value)."
	
	| result |
	phidget isAttached ifFalse: [ ^ 0.0 ].
	result := self class
		primGetPosition: phidget id
		at: index - 1.
	^ result
		ifNotNil: [ result ]
		ifNil: [ 0.0 ]! !

!PhdCrCompServoMotor methodsFor: 'accessing' stamp: 'lk 6/16/2009 20:11'!
position: aValue
	"Set the position of the motor.
	aValue should be a number betwenn self positionMin and self positionMax (inclusivly).
	Returns true if the setting was successful, false otherwise."
	
	| aFloat |
	phidget isAttached ifFalse: [ ^ false ].
	aFloat := aValue asFloat.
	(self positionIsInRange: aFloat) ifFalse: [ ^ false ].
	^ (self class
		primSetPosition: phidget id
		at: index - 1
		to: aFloat) == 1! !

!PhdCrCompServoMotor methodsFor: 'accessing' stamp: 'lk 6/16/2009 20:12'!
positionIsInRange: position
	"Return true if the position is in range of this motor, false otherwise.
	The position is in range if the Phidget is attached and the position is between the min. and max. position."
	
	phidget isAttached ifFalse: [ ^ false ].
	self positionMin <= position ifFalse: [ ^ false ].
	self positionMax >= position ifFalse: [ ^ false ].
	^ true! !

!PhdCrCompServoMotor methodsFor: 'accessing' stamp: 'lk 6/16/2009 20:12'!
positionMax
	"Returns the max. allowed motor position for this motor.
	If it cannot be retrieved it is 0.0 (although this may also be a valid value)."
	
	| result |
	phidget isAttached ifFalse: [ ^ 0.0 ].
	result := self class
		primGetMaxPosition: phidget id
		at: index - 1.
	^ result
		ifNotNil: [ result ]
		ifNil: [ 0.0 ]! !

!PhdCrCompServoMotor methodsFor: 'accessing' stamp: 'lk 6/16/2009 20:13'!
positionMin
	"Returns the min. allowed motor position for this motor.
	If it cannot be retrieved it is 0.0 (although this may also be a valid value)."
	
	| result |
	phidget isAttached ifFalse: [ ^ 0.0 ].
	result := self class
		primGetMinPosition: phidget id
		at: index - 1.
	^ result
		ifNotNil: [ result ]
		ifNil: [ 0.0 ]! !

!PhdCrCompServoMotor methodsFor: 'prototyp' stamp: 'pt 6/23/2009 18:50'!
positionNumber: aNumber

	| max min |
	( 0 <= aNumber and: [ aNumber <= 1000 ] ) ifFalse: [ ^ self ].
	max := self positionMax.
	min := self positionMin.
	min == -1000 ifFalse: [
		self position: max - min * (aNumber asFloat) / 1000.0 + min ].! !

!PhdCrMultiComponent class methodsFor: 'multi-component' stamp: 'lk 6/16/2009 20:39'!
componentCount: phidget
	"Returns the number of components in a multicomponent phidget.
	Uses a primitive the subclasses must define. This primitive can for example do a call to get the number of sensors on an InterfaceKit.
	If there was an error getting the value, 0 is returned."
	
	phidget isAttached ifTrue: [ | result |
		result := self primComponentCount: phidget id.
		result ifNil: [ ^ 0 ].
		^ result ].
	 ^ 0! !

!PhdCrMultiComponent class methodsFor: 'multi-component' stamp: 'lk 6/16/2009 20:40'!
getListFor: phidget
	"Answers a LinkedList of instances of my class, with self componentCount elements, each initialized with its index in the list."

	| list size |
	list := LinkedList new.
	size := self componentCount: phidget.
	
	(1 to: size) do: [ :i |
		list add: (self newWith: phidget index: i) ].
	^ list! !

!PhdCrMultiComponent class methodsFor: 'instance creation' stamp: 'lk 6/16/2009 20:38'!
newWith: phidget index: index
	"Create and return a new MultComponent with given Phidget 'parent' and index.
	Once those values are set, they are never changed again."

	^ (self newWith: phidget)
		setIndex: index! !

!PhdCrMultiComponent class methodsFor: 'multi-component' stamp: 'lk 6/16/2009 20:52'!
primComponentCount: phidgetIdArray
	"Gets the number of components for a phidget multi component.
	This can for instance be a primitive to get the number of sensors on an InterfaceKit."

	self subclassResponsibility.! !

!PhdCrMultiComponent methodsFor: 'accessing' stamp: 'lk 6/1/2009 18:38'!
nextLink

	^ nextLink! !

!PhdCrMultiComponent methodsFor: 'accessing' stamp: 'lk 6/1/2009 18:38'!
nextLink: aMultiComponent

	nextLink := aMultiComponent.! !

!PhdCrMultiComponent methodsFor: 'accessing' stamp: 'lk 6/1/2009 18:17'!
setIndex: aNumber
	"Set my 'index' instance variable to the given one.
	If I already have an index, do nothing."
	
	index ifNil: [ index := aNumber ].! !

Object subclass: #PhdCrPhidget
	instanceVariableNames: 'opened semaphores userProcessBlocks id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

PhdCrPhidget class
	instanceVariableNames: 'SystemCallbacks'!

!PhdCrPhidget commentStamp: 'lk 6/16/2009 16:17' prior: 0!
I am an abstract class that provides some primitives and methods for Phidget support. Please read the comments of my subclasses to find more information how to use Phidgets in Squeak.

Instance Variables
	id:						<ByteArray>
	opened:					<Boolean>
	userProcessBlocks:	<Dictionary> (Symbol -> Block)
	semaphores:				<Dictionary> (Symbol -> Semaphore)
Class Instance Variables
	SystemCallback:		<Dictionary> (Symbol -> Symbol)
	
id
	- a ByteArray that contains the Phidget's unique identifier for the C API. Every primitive (except the one where the handle is created) needs this ByteArray to let the C API know about which Phidget it is currently talking to.
	- the id is obtained when creating the phidget object and will stay there until the object is deleted or the id became invalid (see checkInvalid method).
	- an id can become invalid if the phidget is created, the Squeak image saved, closed and then reloaded. As the plugin was shutdown when the VM is closed, the hardware connection to the phidget is broken. checkValid checks the id and resets it to a default value if the id has become invalid. This object cannot be used for communication with any Phidget anymore.
	- checkValid should be called before doing any primitve with a phidget id.

opened
	- true, if the Phidget was opened - Squeak is able to communicate with the hardware. This does not mean there is a Phidget attached.
	- false, if the Phidgets was not opened or was opened and then closed.

semaphores
	- A Dictionary with entries of the following form: aSymbol -> aSemaphore.
	aSymbol may be #Attach, #Detach, #Error for Phidgets in general. Other symbols may exist for phidget specific support in my subclasses. My classes method 'knownCallback' answers a list of callbacks I know.
	I use this dictionary to handle the callbacks from the Phidget C API.
	These semaphores can be registered for certain events (like the attach event) - so that the C API signals is if the event occours. These semaphores are used in my callbackProcess method.

userProcessBlocks
	- a Dictionary with entries of the following form: aSymbol -> aBlock.
	The symbols are equivalent to the symbols used in the semaphores dictionary.
	I use this dictionary to handle the callbacks from the Phidget C API.
	Each time a semaphore from the semaphores dictionary was signaled from the C API, I evaluate the corresponding block from this dictionary in the callbackProcess method.
	In the base class possible callbacks are: #Attach, #Detach, #Error

SystemCallbacks
	My class has a method called 'systemCallbacks'. This Dictionary is similar to the userProcessBlocks: It maps from callbackNames to message selectors. Those messages willbe sent when the semaphore at 'callbackName' is signaled.
	In contrast to userProcessBlocks this Dictionary is immutable to the user. Currently it is only used for initializing and deleting phidget components an attaching/detaching (see below).

About Components:
	A phidget can have several components, e.g. a list of outputs or a LED. Those components derive from the PhdCrComponent class. See its documentation to lern more about them.
	When a phidget is attached, it initializes its components using 'initializeComponents'. When the phidget is detached or closed, 'deleteComponents' deletes them again.
	A Component a Phidget can have is represented by an instance variable in that class. Add a getter and initialisation/deletion instructions in initialize / initializeComponents / deleteComponents.
	As there are different Phidgets per phidget class, the umber of components can differ. A InterfaceKit can for instance have 8 sensors, others might have none. The implementations of initializeComponents, delete components and initialize must be aware of that.

IMPORTANT:
After using the Phidget it is important to close the connection to the hardware by sending 'close':
	phidget close.	!

PhdCrPhidget class
	instanceVariableNames: 'SystemCallbacks'!

PhdCrPhidget subclass: #PhdCrAccelerometer
	instanceVariableNames: 'axes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrAccelerometer commentStamp: 'sp 7/1/2009 12:34' prior: 0!
I am a representation of a Phidget called 'Accelerometer' in Squeak.
To use a Accelerometer, create a new instance and open a connection to the hardware board with:
	accel := PhdCrInterfaceKit new.
	accel openAny.
Send me a block to be evaluated every time the hardware board was attached, detached, an error or acceleration occoured.
For example:
	accel
		on: #Attach do: [ Transcript show:'accel was attached!!';cr ];
		on: #Detach do: [ Transcript show:'accel was detached!!';cr];
		on: #AccelerationChange do: [ Transcript show:'A axis changed it's value!!' ].


Instance Variables
	axes:		<LinkedList of PhdCrCompDigitalOutput's>

axes:
	- a LinkedList. This list is empty if no Phidget is attached. When a Phidget is attached this list is automatically filled with as many PhdCrComponent's as the Phidget has. When the Phidget is detached the list is emptied. See the instance's class documentation for more information.


new callbacks:
	#AccelerationChange (an axis has occured an acceleration)!

!PhdCrAccelerometer class methodsFor: 'callbacks' stamp: 'sp 6/18/2009 17:42'!
knownCallbacks
	"Returns a list of callback names (#symbols) the Accelerometer knows.
	This extends the list the super class knows."
	
	^ super knownCallbacks, #( #AccelerationChange )! !

!PhdCrAccelerometer class methodsFor: 'primitives' stamp: 'sp 6/18/2009 17:43'!
primCreate
	"Create a new the Acceleration object. Returns a new id for the Phidget, or nil if there was an error."

	<primitive: 'primAccelerometerCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrAccelerometer methodsFor: 'accessing' stamp: 'sp 6/18/2009 17:45'!
axes
	^ axes! !

!PhdCrAccelerometer methodsFor: 'accessing' stamp: 'pt 6/26/2009 13:22'!
changeSensitivity
	| aNumber |
	
	self axes size = 0 ifTrue: [^ 0.0].
	self axes do: [:axis | aNumber := aNumber + axis sensitivity].
	^ aNumber asFloat / self axes size asFloat! !

!PhdCrAccelerometer methodsFor: 'accessing' stamp: 'pt 6/26/2009 13:22'!
changeTrigger 
	| aNumber |
	
	self axes size = 0 ifTrue: [^ 0.0].
	self axes do: [:axis | aNumber := aNumber + axis changeTrigger].
	^ aNumber asFloat / self axes size asFloat! !

!PhdCrAccelerometer methodsFor: 'accessing' stamp: 'pt 6/26/2009 11:24'!
changeTrigger: aNumber
 self axes do: [:axis | axis changeTrigger: aNumber].! !

!PhdCrAccelerometer methodsFor: 'initialize-open-close' stamp: 'sp 6/18/2009 17:40'!
deleteComponents
	"This method is called when the Accelerometer is detached. It delets previously in 'initializeComponents' built component axes."

	axes := LinkedList new.! !

!PhdCrAccelerometer methodsFor: 'initialize-open-close' stamp: 'sp 6/18/2009 17:36'!
initialize
	"additionally reset my components."

	super initialize.
	
	axes := LinkedList new.! !

!PhdCrAccelerometer methodsFor: 'initialize-open-close' stamp: 'sp 6/18/2009 23:23'!
initializeComponents
	"This method is called when an Accelerometer is attached. It initializes its component axes.
	The component will be deleted in 'deleteComponents' on detaching."

	axes := PhdCrCompAxis getListFor: self.! !

!PhdCrAccelerometer methodsFor: 'initialize-open-close' stamp: 'sp 6/18/2009 21:19'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. Extends the superclasses' method by adding semaphores for
	#AxisChange."
	
	| semaIndex |
	super registerSemaphores.
	
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #AccelerationChange).
	PhdCrCompAxis
		primSetSemaphoreIndexChange: semaIndex
		for: id.! !

!PhdCrAccelerometer methodsFor: 'accessing' stamp: 'pt 6/26/2009 11:23'!
sensitivity: aNumber
 self axes do: [:axis | axis sensitivity: aNumber].! !

PhdCrPhidget subclass: #PhdCrInterfaceKit
	instanceVariableNames: 'sensors inputs outputs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrInterfaceKit commentStamp: 'sp 7/1/2009 12:35' prior: 0!
I am a representation of a Phidget called 'Interface Kit' in Squeak.
To use a Interface Kit, create a new instance and open a connection to the hardware board with:
	ifKit := PhdCrInterfaceKit new.
	ifKit openAny.
Send me a block to be evaluated every time the hardware board was attached, detached, an error occoured, a sensor value was changed, an input value was changed or an output value was changed. For example:
	ifKit
		on: #Attach do: [ Transcript show:'ifKit was attached!!';cr ];
		on: #Detach do: [ Transcript show:'ifKit was detached!!';cr ];
		on: #SensorChange do: [ Transcript show:'A sensor changed it's value!!' ].


Instance Variables
	sensors:		<LinkedList of PhdCrCompAnalogSensor's>
	inputs:		<LinkedList of PhdCrCompDigitalInput's>
	outputs:		<LinkedList of PhdCrCompDigitalOutput's>

sensors / inputs / outputs: (each)
	- a LinkedList. This list is empty if no Phidget is attached. When a Phidget is attached this list is automatically filled with as many PhdCrComponent's as the Phidget has. When the Phidget is detached the list is emptied. See the instance's class documentation for more information.


new callbacks:
	#SensorChange (a sensor has changed its value),
	#InputChange (an input has changed its value),
	#OutputChange (an output has changed its value)
!

!PhdCrInterfaceKit class methodsFor: 'callbacks' stamp: 'lk 5/12/2009 12:23'!
knownCallbacks
	"Returns a list of callback names (#symbols) the InterfaceKit knows.
	This extends the list the super class knows."
	
	^ super knownCallbacks, #( #SensorChange #InputChange #OutputChange )! !

!PhdCrInterfaceKit class methodsFor: 'primitives' stamp: 'lk 6/16/2009 21:17'!
primCreate
	"Create a new the Interface Kit object. Returns a new id for the Phidget, or nil if there was an error."

	<primitive: 'primInterfaceKitCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'initialize-open-close' stamp: 'lk 6/15/2009 13:36'!
deleteComponents
	"This method is called when the InterfaceKit is detached. It delets previously in 'initializeComponents' built components: sensors, inputs, outputs."

	sensors := LinkedList new.
	inputs := LinkedList new.
	outputs := LinkedList new.! !

!PhdCrInterfaceKit methodsFor: 'initialize-open-close' stamp: 'lk 6/16/2009 21:04'!
initialize
	"additionally reset my components."

	super initialize.
	
	inputs := LinkedList new.
	outputs := LinkedList new.
	sensors := LinkedList new.! !

!PhdCrInterfaceKit methodsFor: 'initialize-open-close' stamp: 'lk 6/15/2009 14:59'!
initializeComponents
	"This method is called when an InterfaceKit is attached. It initializes its components: sensors, inputs, outputs.
	The components will be deleted in 'deleteComponents' on detaching."
	
	sensors := PhdCrCompAnalogSensor getListFor: self.
	inputs := PhdCrCompDigitalInput getListFor: self.
	outputs := PhdCrCompDigitalOutput getListFor: self.! !

!PhdCrInterfaceKit methodsFor: 'accessing' stamp: 'lk 6/15/2009 16:13'!
inputs
	^ inputs! !

!PhdCrInterfaceKit methodsFor: 'accessing' stamp: 'lk 6/15/2009 16:13'!
outputs
	^ outputs! !

!PhdCrInterfaceKit methodsFor: 'initialize-open-close' stamp: 'lk 6/15/2009 16:07'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. Extends the superclasses' method by adding semaphores for #SensorChange, #InputChange and #OutputChange."
	
	| semaIndex |
	super registerSemaphores.
	
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #SensorChange).
	PhdCrCompAnalogSensor
		primSetSemaphoreIndexChange: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #InputChange).
	PhdCrCompDigitalInput
		primSetSemaphoreIndexChange: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #OutputChange).
	PhdCrCompDigitalOutput
		primSetSemaphoreIndexChange: semaIndex
		for: id.! !

!PhdCrInterfaceKit methodsFor: 'accessing' stamp: 'lk 6/15/2009 16:14'!
sensors
	^ sensors! !

PhdCrPhidget subclass: #PhdCrMotorControl
	instanceVariableNames: 'motors inputs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrMotorControl commentStamp: 'sp 7/1/2009 13:03' prior: 0!
I am a representation of a Phidget called 'Motor Control' in Squeak.
To use a Motor Control, create a new instance and open a connection to the hardware board with:
	motorControl := PhdCrMotorControl new.
	motorControl openAny.
Send me a block to be evaluated every time the hardware board was attached, detached, an error occoured, the velocity of a motor was changed, the current of a motor was changed or an input value was changed.
For example:
	motorControl
		on: #Attach do: [ Transcript show:'motorControl was attached!!';cr ];
		on: #Detach do: [ Transcript show:'motorControl was detached!!';cr ];
		on: #VelocityChange do: [ Transcript show:'A motor changed it's velocity!!' ];
		on: #CurrentChange do: [ Transcript show:'The current draw for a motor has changed!!' ].


Instance Variables
	motors:		<LinkedList of PhdCrCompMotor's>
	inputs:		<LinkedList of PhdCrCompDigitalInput's>

motors / inputs: (each)
	- a LinkedList. This list is empty if no Phidget is attached. When a Phidget is attached this list is automatically filled with as many PhdCrComponent's as the Phidget has. When the Phidget is detached the list is emptied. See the instance's class documentation for more information.


new callbacks:
	#VelocityChange (a motor has changed its velocity),
	#CurrentChange (a motor has changed its current draw),
	#InputChange (an input has changed its value)!

!PhdCrMotorControl class methodsFor: 'callbacks' stamp: 'sp 6/24/2009 14:18'!
knownCallbacks
	"Returns a list of callback names (#symbols) the MotorControl knows.
	This extends the list the super class knows."
	
	^ super knownCallbacks, #( #VelocityChange #CurrentChange #InputChange )! !

!PhdCrMotorControl class methodsFor: 'primitives' stamp: 'sp 6/24/2009 14:17'!
primCreate
	"Create a new the Motor Control object. Returns a new id for the Phidget, or nil if there was an error."

	<primitive: 'primMotorControlCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrMotorControl methodsFor: 'initialize-open-close' stamp: 'sp 6/24/2009 13:46'!
deleteComponents
	"This method is called when the MotorControl is detached. It delets previously in 'initializeComponents' built components: motors and inputs."

	motors := LinkedList new.
	inputs := LinkedList new.! !

!PhdCrMotorControl methodsFor: 'initialize-open-close' stamp: 'sp 6/24/2009 13:40'!
initialize
	"additionally reset my components."

	super initialize.
	
	motors := LinkedList new.
	inputs := LinkedList new.! !

!PhdCrMotorControl methodsFor: 'initialize-open-close' stamp: 'sp 6/24/2009 13:43'!
initializeComponents
	"This method is called when a MotorControl is attached. It initializes its components: motors and inputs.
	The components will be deleted in 'deleteComponents' on detaching."
	
	motors := PhdCrCompMotor getListFor: self.
	inputs := PhdCrCompDigitalInput getListFor: self.! !

!PhdCrMotorControl methodsFor: 'accessing' stamp: 'sp 6/24/2009 13:51'!
inputs
	^ inputs! !

!PhdCrMotorControl methodsFor: 'accessing' stamp: 'sp 6/24/2009 13:50'!
motors
	^ motors! !

!PhdCrMotorControl methodsFor: 'initialize-open-close' stamp: 'sp 6/25/2009 13:26'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. Extends the superclasses' method by adding semaphores for #VelocityChange, #CurrentChange and #InputChange"
	
	| semaIndex |
	super registerSemaphores.
	
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #VelocityChange).
	PhdCrCompMotor
		primSetSemaphoreIndexVelocityChange: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #CurrentChange).
	PhdCrCompMotor
		primSetSemaphoreIndexCurrentChange: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #InputChange).
	PhdCrCompDigitalInput
		primSetSemaphoreIndexChange: semaIndex
		for: id.! !

!PhdCrPhidget class methodsFor: 'callbacks' stamp: 'lk 6/16/2009 21:14'!
knownCallbacks
	"Returns a list of callback names (#symbols) the Phidget knows. A subclass may extend this list if needed."
	
	^ #( #Attach #Detach #Error )! !

!PhdCrPhidget class methodsFor: 'accessing' stamp: 'lk 6/16/2009 21:15'!
lastError
	"Returns the error code of the last error in the PhidgetPlugin, or nil if something went wrong.
	Descriptions of the codes may be found on www.phidgets.com or phidget21.h in line 2250 ff."

	^ self primLastError! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/16/2009 21:15'!
primClose: phidgetidArray
	"Close the Phidget with given id. 
	Return 1 if the operation succeeded, or other values otherwise."
	
	<primitive: 'primClose' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/16/2009 21:14'!
primIsAttached: phidgetidArray
	"Returns 1 if the Phidget is attached, and other values otherwise."
	
	<primitive: 'primIsAttached' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/16/2009 21:15'!
primIsValid: phidgetidArray
	"Returns 1 if the Phidget id is valid, or other values otherwise."
	
	<primitive: 'primIsValid' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/16/2009 21:15'!
primLastError
	"Returns the error code of the last error in the Plugin, or nil if something went wrong.
	Descriptions of the codes may be found on www.phidgets.com or phidget21.h in line 2250 ff."

	<primitive: 'primLastError' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/16/2009 21:16'!
primOpen: phidgetidArray withSerial: serial
	"Opens the Phidget with the given serial number.
	Return 1 if the operation succeeded, or other values otherwise."

	<primitive: 'primOpen' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/16/2009 21:16'!
primSetSemaphoreIndexAttach: semaphoreIndex for: phidgetidArray
	"registers the given Semaphore to be signaled when the Phidget with given id is attached.
	Return 1 if the operation succeeded, or other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexAttach' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/16/2009 21:16'!
primSetSemaphoreIndexDetach: semaphoreIndex for: phidgetidArray
	"registers the given Semaphore to be signaled when the Phidget with given id is attached.
	Return 1 if the operation succeeded, or other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexDetach' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/16/2009 21:16'!
primSetSemaphoreIndexError: semaphoreIndex for: phidgetidArray
	"registers the given Semaphore to be signaled when the Phidget with given id is attached.
	Return 1 if the operation succeeded, or other values otherwise."
	
	<primitive: 'primSetSemaphoreIndexError' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'callbacks' stamp: 'lk 6/1/2009 17:04'!
systemCallbacks
	"This Method answers a Doctionary similar to the instance's userProcessBlocks.
	It may for instance contain message selectors sent when attaching or detaching a phidget, so the phidget components can be initialized."
	
	SystemCallbacks ifNotNil: [ ^ SystemCallbacks ].
	
	SystemCallbacks := Dictionary new.
	SystemCallbacks
		add: #Attach -> #initializeComponents;
		add: #Detach -> #deleteComponents.
	^ SystemCallbacks! !

!PhdCrPhidget methodsFor: 'callbacks' stamp: 'lk 6/16/2009 21:07'!
callbackProcess: callbackName 
	"This method will be forked as an extra process for every callback that a phidget needs.
	The semaphores were previously initialised and registered as external objects.
	self class knownCallbacks lists all possible semaphore names.
	systemCallbacks contains message selectors to be sent."
	
	(semaphores at: callbackName) wait.
	
	[ self isOpen ] whileTrue: [
		(self class systemCallbacks includesKey: callbackName) 
			ifTrue: [ self perform: (self class systemCallbacks at: callbackName) ].
		(userProcessBlocks at: callbackName) value.
		
		(semaphores at: callbackName) wait
	]! !

!PhdCrPhidget methodsFor: 'testing' stamp: 'lk 6/15/2009 13:46'!
checkValid
	"Checks if the Phidgets has an id and if this id is valid."

	^ id isNil not and: [ | result |
		result := (self class primIsValid: id) == 1.
		result ifFalse: [
			"this may have happened if a Phidget was created and then the image was saved,
			closed and reloaded. The hardware connection is broken. We need to make this
			instance fully invalid."
			id := nil.
			self close ].
		result ]! !

!PhdCrPhidget methodsFor: 'initialize-open-close' stamp: 'lk 6/16/2009 21:07'!
close
	"Close the Phidget."
	
	self isOpen ifFalse: [ ^ self ].	"already closed"
	
	self class primClose: id.
	opened := false.
	self
		unregisterSemaphores;
		deleteComponents.! !

!PhdCrPhidget methodsFor: 'callbacks' stamp: 'lk 6/1/2009 00:47'!
createCallbackProcessBlock: callbackName
	"Create a callback process block to be forked.
	Must be swapped out to work in loops."

	^ [ self callbackProcess: callbackName ]! !

!PhdCrPhidget methodsFor: 'initialize-open-close' stamp: 'lk 6/1/2009 12:41'!
deleteComponents
	"This method is called when a Phidget is detached. It should delete previously in 'initializeComponents' built components, e.g. outputs, sensors, ...
	The abstract phidget does not have components, so it does nothing here."! !

!PhdCrPhidget methodsFor: 'callbacks' stamp: 'lk 6/1/2009 12:05'!
forkCallbacks
	"Fork the callback processes."
	
	self class knownCallbacks do: [ :callbackName |
		(self createCallbackProcessBlock: callbackName) fork ].! !

!PhdCrPhidget methodsFor: 'accessing' stamp: 'lk 6/15/2009 11:24'!
id
	^ id! !

!PhdCrPhidget methodsFor: 'initialize-open-close' stamp: 'lk 6/16/2009 21:06'!
initialize
	"Initialise the callbacks that are used in every Phidget.
	Every subclass should call super initialise or initialise the callbacks by their own.
	In addition mark phidget as opened and create the representation in the plugin using a primitive."
	
	super initialize.
	
	semaphores := Dictionary new.
	userProcessBlocks := Dictionary new.
	opened := false.
	
	self class knownCallbacks do: [ :name | 
		semaphores add: name -> Semaphore new.
		userProcessBlocks add: name -> [] ].
	
	id := self class primCreate.! !

!PhdCrPhidget methodsFor: 'initialize-open-close' stamp: 'lk 6/1/2009 12:41'!
initializeComponents
	"This method is called when a Phidget is attached. It should initialize its components (sensors, outputs, ...).
	The components will be deleted in 'deleteComponents' on detaching.
	The abstract phidget does not have components, so it does nothing here."! !

!PhdCrPhidget methodsFor: 'testing' stamp: 'lk 6/15/2009 20:34'!
isAttached
	"Returns true if the Phidget is attached, and false otherwise."

	^ self checkValid & opened and: [ (self class primIsAttached: id) == 1 ]! !

!PhdCrPhidget methodsFor: 'testing' stamp: 'lk 6/16/2009 21:09'!
isOpen
	"return true if I am open (having a hardware connection to a Phidget or waitng for one).
	Also make sure I am sill valid."

	^ self checkValid and: [ opened ]! !

!PhdCrPhidget methodsFor: 'accessing' stamp: 'lk 6/16/2009 21:09'!
on: callbackName do: aBlock 
	"aBlock will be evaluated when the semaphore at callbackName is signaled.
	self class knownCallbacks lists all possible callback names."
	
	(self class knownCallbacks includes: callbackName) ifTrue: [
		userProcessBlocks 
			at: callbackName
			put: aBlock ].! !

!PhdCrPhidget methodsFor: 'initialize-open-close' stamp: 'lk 6/15/2009 13:09'!
openAny
	"opens hardware connection to any phidget with matching class."

	^ self openWithSerial: -1! !

!PhdCrPhidget methodsFor: 'initialize-open-close' stamp: 'lk 6/16/2009 21:10'!
openWithSerial: serialNumber 
	"Opens the Phidget with the given serial number.
	Opens any Phidgets of matching class if serialNumber is -1."

	(self checkValid and: [self isOpen not]) ifFalse: [ ^ self ].
	
	self registerSemaphores.
	self class
		primOpen: id
		withSerial: serialNumber.
	opened := true.
	self forkCallbacks.! !

!PhdCrPhidget methodsFor: 'initialize-open-close' stamp: 'lk 6/15/2009 12:32'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. May be extended in subclasses."
	
	| semaIndex |
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #Attach).
	self class
		primSetSemaphoreIndexAttach: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #Detach).
	self class
		primSetSemaphoreIndexDetach: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #Error).
	self class
		primSetSemaphoreIndexError: semaIndex
		for: id.! !

!PhdCrPhidget methodsFor: 'testing' stamp: 'lk 6/16/2009 21:10'!
testSemaphoresReset
	"Answer true if the semaphores are reset, false otherwise."

	id do: [ :byte | byte isZero ifFalse: [ ^ false ] ].
	^ true! !

!PhdCrPhidget methodsFor: 'initialize-open-close' stamp: 'lk 6/16/2009 21:11'!
unregisterSemaphores
	"Unregister the semaphores which were previously registered with 'self registerSemaphores'."

	semaphores do: [ :sema |
		"If I am not opened and the semaphore is signaled, the callback process will terminate."
		opened := false.
		sema signal.
		
		Smalltalk unregisterExternalObject: sema
	].! !

PhdCrPhidget subclass: #PhdCrRFID
	instanceVariableNames: 'rfid led outputs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrRFID commentStamp: 'lk 6/16/2009 16:39' prior: 0!
I am a representation of a Phidget called 'Phidget RFID' in Squeak.
To use the RFID Phidget, create a new instance and open a connection to the hardware board with:
	rfid := PhdCrRFID new.
	rfid openAny.
A block can be set to be evaluated every time the hardware board was attached, detached, an error occoured, an output value was changed, a tag was found by the RFID reader, or if the tag was lost. For example:
	rfid
		on: #Attach do: [ Transcript show:'rfid was attached!!';cr ];
		on: #Detach do: [ Transcript show:'rfid was detached!!';cr ];
		on: #TagFound do: [ Transcript show:'rfid found a tag';cr ].


Instance Variables
	rfid:			<PhdCrCompRFID>
	outputs:		<LinkedList of PhdCrCompDigitalOutput's>
	led:			<PhdCrCompSimpleLED>

rfid:
	- a PhdCrCompRFID needed to get tag information of the RFID Phidget. See the PhdCrCompRFID class documentation for more information.

outputs:
	- a LinkedList. This list is empty if no Phidget is attached. When a Phidget is attached this list is automatically filled with as many PhdCrCompDigitalOutput's as the Phidget has. When the Phidget is detached the list is emptied. See the PhdCrCompDigitalOutput class documentation for more information.

led:
	- a PhdCrCompSimpleLED that is on-board on this type of Phidget. See the PhdCrCompSimpleLED class documentation for more information.


new callbacks:
	#TagFound (a tag was found by the rfid sensor),
	#TagLost (a tag was found by the rfid sensor),
	#OutputChange (an output has changed its value)


example indicating if a tag was found using the on-board LED
	rfid := PhdCrRFID new.
	rfid
		on: #Attach do: [ rfid rfidSensor setAntennaState: true ];
		on: #TagFound do: [ rfid led setState: true ];
		on: #TagLost do: [ rfid led setState: false ];
		openAny.
	"Now attach a RFID Phidget, hold a tag near the Phidget and then take it away."
	rfid close.!

!PhdCrRFID class methodsFor: 'callbacks' stamp: 'lk 5/30/2009 20:03'!
knownCallbacks
	"Returns a list of callback names (#symbols) the RFID Phidget knows.
	This extends the list the super class knows."
	
	^ super knownCallbacks, #( #OutputChange #TagFound #TagLost )! !

!PhdCrRFID class methodsFor: 'primitives' stamp: 'lk 6/16/2009 21:18'!
primCreate
	"Create a new the RFID object. Returns a new id for the Phidget, or nil if there was an error."

	<primitive: 'primRFIDCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'initialize-open-close' stamp: 'lk 6/15/2009 20:31'!
deleteComponents
	"This method is called when the RFID Phidget is detached. It delets previously in 'initializeComponents' built components: outputs"

	outputs := LinkedList new.! !

!PhdCrRFID methodsFor: 'initialize-open-close' stamp: 'lk 6/16/2009 21:11'!
initialize
	"additionally reset my components."

	super initialize.
	
	rfid := PhdCrCompRFID newWith: self.
	led := PhdCrCompSimpleLED newWith: self.
	outputs := LinkedList new.! !

!PhdCrRFID methodsFor: 'initialize-open-close' stamp: 'fs 7/5/2009 18:47'!
initializeComponents
	"This method is called when a RFID Phidget is attached. It initializes its components:  outputs, rfid, led.
	The components will be deleted in 'deleteComponents' on detaching."

	outputs := PhdCrCompDigitalOutput getListFor: self.! !

!PhdCrRFID methodsFor: 'accessing' stamp: 'lk 6/15/2009 21:21'!
led
	^ led! !

!PhdCrRFID methodsFor: 'accessing' stamp: 'lk 6/15/2009 16:15'!
outputs
	^ outputs! !

!PhdCrRFID methodsFor: 'initialize-open-close' stamp: 'lk 6/15/2009 17:31'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. Extends the superclasses' method by adding semaphores for #OutputChange, #TagFound and #TagLost."
	
	| semaIndex |
	super registerSemaphores.
	
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #OutputChange).
	PhdCrCompDigitalOutput
		primSetSemaphoreIndexChange: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #TagFound).
	PhdCrCompRFID
		primSetSemaphoreIndexTagFound: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #TagLost).
	PhdCrCompRFID
		primSetSemaphoreIndexTagLost: semaIndex
		for: id.! !

!PhdCrRFID methodsFor: 'accessing' stamp: 'lk 6/15/2009 21:20'!
rfidSensor
	^ rfid! !

PhdCrPhidget subclass: #PhdCrServo
	instanceVariableNames: 'motors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrServo commentStamp: 'sp 7/1/2009 12:35' prior: 0!
I am a representation of a Phidget called 'Servo' (here: 'Servo board') in Squeak.
To use the Servo board, create a new instance and open a connection to the hardware board with:
	servo := PhdCrServo new.
	servo openAny.
A block can be set to be evaluated every time the hardware board was attached, detached, an error occoured or the position of a motor was changed. For example:
	servo
		on: #Attach do: [ Transcript show:'servo was attached!!';cr ];
		on: #Detach do: [ Transcript show:'servo was detached!!';cr ];
		on: #PositionChange do: [ Transcript show:'A motor changed it's position!!' ].


Instance Variables
	motors:		<LinkedList of PhdCrCompServoMotor's>

motors:
	- a LinkedList of PhdCrCompServoMotor's. This list is empty if no Phidget is attached. When a Phidget is attached this list is automatically filled with as many PhdCrCompServoMotor's as the Phidget has. When the Phidget is detached the list is emptied. See the PhdCrCompServoMotor class documentation for more information.


new callbacks:
	#PositionChange (a motor has changed its position)
!

PhdCrServo subclass: #PhdCrAdvancedServo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrAdvancedServo commentStamp: 'sp 7/1/2009 13:07' prior: 0!
I am a representation of a Phidget called 'Advanced Servo' (here: 'Advanced Servo board') in Squeak.
Furthermore I'm a special Servo board. I additionally support acceleration and velocity for a motor.
To use the Advanced Servo board, create a new instance and open a connection to the hardware board with:
	advServo := PhdCrAdvancedServo new.
	advServo openAny.
A block can be set to be evaluated every time the hardware board was attached, detached, an error occoured, the position of a motor was changed, the velocity of a motor was changed or the current draw of a motor was changed. For example:
	servo
		on: #Attach do: [ Transcript show:'servo was attached!!';cr ];
		on: #Detach do: [ Transcript show:'servo was detached!!';cr ];
		on: #VelocityChange do: [ Transcript show:'A motor changed it's velocity!!' ];
		on: #CurrentChange do: [ Transcript show:'The current draw for a motor has changed!!' ].


Instance Variables
	motors:		<LinkedList of PhdCrCompAdvancedServoMotor's>

motors:
	- a LinkedList of PhdCrCompAdvancedServoMotor's. This list is empty if no Phidget is attached. When a Phidget is attached this list is automatically filled with as many PhdCrCompAdvancedServoMotor's as the Phidget has. When the Phidget is detached the list is emptied. See the PhdCrCompAdvancedServoMotor class documentation for more information.


new callbacks:
	#VelocityChange (a motor has changed its velocity),
	#CurrentChange (a motor has changed its current draw)
!

!PhdCrAdvancedServo class methodsFor: 'callbacks' stamp: 'sp 6/26/2009 06:18'!
knownCallbacks
	"Returns a list of callback names (#symbols) the AdvancedServo knows.
	This extends the list the super class knows."
	
	^ super knownCallbacks, #( #VelocityChange #CurrentChange )! !

!PhdCrAdvancedServo class methodsFor: 'primitives' stamp: 'sp 6/26/2009 06:19'!
primCreate
	"Create a new the Advanced Servo object. Returns a new id for the Phidget, or nil if there was an error."

	<primitive: 'primAdvancedServoCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrAdvancedServo methodsFor: 'initialize-open-close' stamp: 'sp 7/1/2009 13:10'!
initializeComponents
	"This method is called when the Phidget is attached. It initializes its components:  motors.
	The components will be reset in 'deleteComponents' on detaching."

	motors := PhdCrCompAdvancedServoMotor getListFor: self.! !

!PhdCrAdvancedServo methodsFor: 'initialize-open-close' stamp: 'sp 6/26/2009 06:16'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. Extends the superclasses' method by adding a semaphore for #VelocityChange and #CurrentChange."
	
	| semaIndex |
	super registerSemaphores.
	
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #VelocityChange).
	PhdCrCompAdvancedServoMotor
		primSetSemaphoreIndexVelocityChange: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #CurrentChange).
	PhdCrCompAdvancedServoMotor
		primSetSemaphoreIndexCurrentChange: semaIndex
		for: id.! !

!PhdCrServo class methodsFor: 'callbacks' stamp: 'lk 5/12/2009 12:23'!
knownCallbacks
	"Returns a list of callback names (#symbols) the Servo knows.
	This extends the list the super class knows."
	
	^ super knownCallbacks, #( #PositionChange )! !

!PhdCrServo class methodsFor: 'primitives' stamp: 'lk 6/16/2009 21:18'!
primCreate
	"Create a new the Servo object. Returns a new id for the Phidget, or nil if there was an error."

	<primitive: 'primServoCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'initialize-open-close' stamp: 'lk 6/15/2009 21:40'!
deleteComponents
	"This method is called when the Phidget is detached. It resets previously in 'initializeComponents' built components: motors"

	motors := LinkedList new.! !

!PhdCrServo methodsFor: 'initialize-open-close' stamp: 'lk 6/16/2009 21:12'!
initialize
	"additionally reset my components."

	super initialize.
	
	motors := LinkedList new.! !

!PhdCrServo methodsFor: 'initialize-open-close' stamp: 'lk 6/15/2009 21:41'!
initializeComponents
	"This method is called when the Phidget is attached. It initializes its components:  motots.
	The components will be reset in 'deleteComponents' on detaching."

	motors := PhdCrCompServoMotor getListFor: self.! !

!PhdCrServo methodsFor: 'accessing' stamp: 'lk 6/15/2009 21:37'!
motors
	^ motors! !

!PhdCrServo methodsFor: 'initialize-open-close' stamp: 'lk 6/15/2009 22:16'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. Extends the superclasses' method by adding a semaphore for #PositionChange."
	
	| semaIndex |
	super registerSemaphores.
	
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #PositionChange).
	PhdCrCompServoMotor
		primSetSemaphoreIndexPositionChange: semaIndex
		for: id.! !

PhdCrPhidget subclass: #PhdCrTextLCD
	instanceVariableNames: 'textLCD'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrTextLCD class methodsFor: 'as yet unclassified' stamp: 'fs 7/5/2009 21:02'!
primCreate
	"Create a new the Text LCD object. Returns a new id for the Phidget, or nil if there was an error."

	<primitive: 'primTextLCDCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrTextLCD class methodsFor: 'as yet unclassified' stamp: 'fs 7/5/2009 22:41'!
primGetContrast: handle

	<primitive: 'primGetTextLCDContrast' module: 'PhidgetPlugin'>
	^ 42! !

!PhdCrTextLCD class methodsFor: 'as yet unclassified' stamp: 'fs 7/5/2009 22:41'!
primSetContrast: handle to: contrast

	<primitive: 'primSetTextLCDContrast' module: 'PhidgetPlugin'>
	^ 42! !

!PhdCrTextLCD class methodsFor: 'as yet unclassified' stamp: 'fs 7/5/2009 23:14'!
primTestCharacter: handle in: row and: column character: character

	<primitive: 'primSetTextDisplayCharacter' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrTextLCD class methodsFor: 'as yet unclassified' stamp: 'fs 7/5/2009 22:26'!
primTestString: handle in: row string: string

	<primitive: 'primSetTextDisplayString' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrTextLCD methodsFor: 'initialize-open-close' stamp: 'fs 7/5/2009 18:44'!
initialize
	"additionally reset my components."

	super initialize.
	
	textLCD := PhdCrCompTextLCD newWith: self.! !

!PhdCrTextLCD methodsFor: 'accessing' stamp: 'fs 7/5/2009 18:51'!
textLCD
	^ textLCD! !

CircleMorph subclass: #PhdETGyroMorph
	instanceVariableNames: 'angleLine orientationCircle x y z'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

!PhdETGyroMorph methodsFor: 'initialization' stamp: 'pt 7/2/2009 13:51'!
createAndAddAngleLine
	"creates a line (PolygonMorph) as a Submorph to me."
	
	angleLine := self 
		createLineFrom: self center
		to: self center
		color: Color black
		width: 3.
	self
		addMorph: angleLine;
		updateAngleLine.! !

!PhdETGyroMorph methodsFor: 'initialization' stamp: 'pt 7/2/2009 13:50'!
createAndAddOrientationCircle
	
	orientationCircle := CircleMorph new
		color: Color transparent;
		borderColor: Color green darker;
		borderWidth: 2;
		yourself.
	self
		addMorph: orientationCircle;
		updateOrientationCircle.! !

!PhdETGyroMorph methodsFor: 'initialization' stamp: 'pt 7/2/2009 09:47'!
createLineFrom: startPoint to: endPoint color: aColor width: aNumber

	^ PolygonMorph vertices: {startPoint. endPoint}
			color: aColor borderWidth: aNumber borderColor: aColor! !

!PhdETGyroMorph methodsFor: 'initialization' stamp: 'pt 7/2/2009 13:43'!
initialize

	super initialize.
	
	self 
		color: Color white;
		x: 0.0;
		y: 0.0;
		z: 0.0;
		createAndAddAngleLine;
		createAndAddOrientationCircle.! !

!PhdETGyroMorph methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 13:23'!
update
	"update my appereance"
	
	self
		updateAngleLine;
		updateOrientationCircle.! !

!PhdETGyroMorph methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 13:20'!
updateAngleLine

	| radius newPoint |
	radius := self width / 2.0.
	
	newPoint := (x sin * radius * -1) @ (y sin * radius * -1).
	angleLine setVertices: { self center . self center + newPoint }.! !

!PhdETGyroMorph methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 13:53'!
updateOrientationCircle

	self
		updateOrientationCircleColor;
		updateOrientationCircleRadius.
	! !

!PhdETGyroMorph methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 13:52'!
updateOrientationCircleColor

	z < 0
		ifTrue:  [ orientationCircle borderColor: Color red darker ]
		ifFalse: [ orientationCircle borderColor: Color green darker ].
	! !

!PhdETGyroMorph methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 14:19'!
updateOrientationCircleRadius

	| newDiameter |
	
	newDiameter := ((z abs sin * self width) + 2).
	
	orientationCircle
		position: self center - ( newDiameter / 2 @ (newDiameter / 2) );
		extent: newDiameter @ newDiameter.! !

!PhdETGyroMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 11:13'!
x
	^ x! !

!PhdETGyroMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 12:03'!
x: aFloat

	x := aFloat.! !

!PhdETGyroMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 11:13'!
y
	^ y! !

!PhdETGyroMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 12:03'!
y: aFloat

	y := aFloat.! !

!PhdETGyroMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 11:13'!
z
	^ z! !

!PhdETGyroMorph methodsFor: 'accessing' stamp: 'pt 7/2/2009 12:04'!
z: aFloat

	z := aFloat.! !

CircleMorph subclass: #PhdETOnOffStatusMorph
	instanceVariableNames: 'status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

!PhdETOnOffStatusMorph methodsFor: 'as yet unclassified' stamp: 'pt 6/10/2009 08:32'!
initialize
	super initialize.
	self borderWidth: 2.
	self off.! !

!PhdETOnOffStatusMorph methodsFor: 'as yet unclassified' stamp: 'pt 6/10/2009 08:21'!
off
	status := false.
	self borderColor: Color black.
	self color: Color lightGray.! !

!PhdETOnOffStatusMorph methodsFor: 'as yet unclassified' stamp: 'pt 6/10/2009 08:31'!
on
	status := true.
	self borderColor: Color yellow muchDarker.
	self color: Color yellow.! !

!PhdETOnOffStatusMorph methodsFor: 'as yet unclassified' stamp: 'pt 6/10/2009 08:28'!
setStatus: aBoolean
	aBoolean
		ifTrue: [ self on ]
		ifFalse: [ self off ].! !

CircleMorph subclass: #PhdETServoPositionMorph
	instanceVariableNames: 'min max current minMorph maxMorph currentMorph lineExtension shadowMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

!PhdETServoPositionMorph methodsFor: 'initialization' stamp: 'pt 7/2/2009 10:09'!
createAndAddCurrentMorph
	"creates a line (PolygonMorph) as a Submorph to me."
	currentMorph := self 
		createLineFrom: self position
		to: self position + (1 @ 1)
		color: Color black
		width: 3.
	self addMorph: currentMorph! !

!PhdETServoPositionMorph methodsFor: 'initialization' stamp: 'pt 6/3/2009 01:28'!
createAndAddMaxMorph
	maxMorph := self 
		createLineFrom: self position
		to: self position + (1 @ 1)
		color: Color red
		width: 2.
	self addMorph: maxMorph! !

!PhdETServoPositionMorph methodsFor: 'initialization' stamp: 'pt 6/3/2009 02:06'!
createAndAddMinMorph
	minMorph := self 
		createLineFrom: self position
		to: self position + (1 @ 1)
		color: (Color r: 0 g: 0.3 b: 0)
		width: 2.
	self addMorph: minMorph! !

!PhdETServoPositionMorph methodsFor: 'initialization' stamp: 'pt 6/3/2009 16:29'!
createAndAddShadowMorph
	shadowMorph := ( PhdETSegmentOfCircle new )
							circleCenter: self center;
							radius: self width / 2.
	self addMorph: shadowMorph! !

!PhdETServoPositionMorph methodsFor: 'initialization' stamp: 'pt 6/3/2009 12:29'!
createAndAddSubmorphs
	self
		createAndAddMinMorph;
		createAndAddMaxMorph;
		createAndAddCurrentMorph;
		createAndAddShadowMorph.! !

!PhdETServoPositionMorph methodsFor: 'initialization' stamp: 'pt 6/2/2009 16:56'!
createLineFrom: startPoint to: endPoint color: aColor width: aNumber

	^ PolygonMorph vertices: {startPoint. endPoint}
			color: aColor borderWidth: aNumber borderColor: aColor! !

!PhdETServoPositionMorph methodsFor: 'accessing' stamp: 'pt 6/2/2009 16:01'!
current

	^ current! !

!PhdETServoPositionMorph methodsFor: 'accessing' stamp: 'pt 6/3/2009 03:21'!
current: aFloat
	"The float must pass the following condition: 0 <= aFloat <= 360"

	( ( 0 <= aFloat ) and: [ aFloat <= 360 ] )  ifTrue: [
		current := aFloat.
		self updateCurrentMorph ].! !

!PhdETServoPositionMorph methodsFor: 'initialization' stamp: 'pt 6/3/2009 17:20'!
initialize
	super initialize.
	self
		color: Color white;
		createAndAddSubmorphs.
	lineExtension := 4.
	min := 0.
	max := 180.
	current := 90.
	self updateSubmorphs.! !

!PhdETServoPositionMorph methodsFor: 'accessing' stamp: 'pt 6/3/2009 01:24'!
lineExtension
	"The number of pixel the min/max lines are visible (=extend) beyond the circle."

	^ lineExtension! !

!PhdETServoPositionMorph methodsFor: 'accessing' stamp: 'pt 6/3/2009 01:24'!
lineExtension: aNumber
	"The number of pixel the min/max lines are visible (=extend) beyond the circle."

	lineExtension := aNumber.! !

!PhdETServoPositionMorph methodsFor: 'accessing' stamp: 'pt 6/2/2009 16:01'!
max

	^ max! !

!PhdETServoPositionMorph methodsFor: 'accessing' stamp: 'pt 6/3/2009 01:13'!
max: aFloat
	"The float must pass the following condition: 0.0 <= aFloat <= 360.0"

	( ( 0 <= aFloat ) and: [ aFloat <= 360 ] )  ifTrue: [
		max := aFloat.
		self updateMaxMorph ].! !

!PhdETServoPositionMorph methodsFor: 'accessing' stamp: 'pt 6/2/2009 16:01'!
min

	^ min! !

!PhdETServoPositionMorph methodsFor: 'accessing' stamp: 'pt 6/3/2009 01:13'!
min: aFloat
	"The float must pass the following condition: 0.0 <= aFloat <= 360.0"

	( ( 0 <= aFloat ) and: [ aFloat <= 360 ] )  ifTrue: [
		min := aFloat.
		self updateMinMorph ].! !

!PhdETServoPositionMorph methodsFor: 'as yet unclassified' stamp: 'pt 6/3/2009 01:42'!
servoRadians: aFloat
	| f |
	f := aFloat -90.0.
	(f<0) ifTrue: [ f := f + 360.0 ].
	^ f degreesToRadians! !

!PhdETServoPositionMorph methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 09:51'!
updateCurrentMorph

	| p radius |
	radius := self width / 2.0.
	p := ( (self servoRadians: self current) cos * radius )
		@ ( (self servoRadians: self current) sin * radius ).
	currentMorph setVertices: { self center . self center + p }.! !

!PhdETServoPositionMorph methodsFor: 'as yet unclassified' stamp: 'pt 6/3/2009 17:19'!
updateMaxMorph

	| p1 p2 r x y |
	r := self width / 2.0.
	x := (self servoRadians: self max) cos.
	y := (self servoRadians: self max) sin.
	p1 := ( x * ( r - self lineExtension ) ) @ ( y * ( r - self lineExtension ) ).
	p2 := ( x * ( r + self lineExtension ) ) @ ( y * ( r + self lineExtension ) ).
	maxMorph setVertices: { self center + p1 . self center + p2 }.
	self updateShadowMorph.! !

!PhdETServoPositionMorph methodsFor: 'as yet unclassified' stamp: 'pt 6/3/2009 17:19'!
updateMinMorph

	| p1 p2 r x y |
	r := self width / 2.0.
	x := (self servoRadians: self min) cos.
	y := (self servoRadians: self min) sin.
	p1 := ( x * ( r - self lineExtension ) ) @ ( y * ( r - self lineExtension ) ).
	p2 := ( x * ( r + self lineExtension ) ) @ ( y * ( r + self lineExtension ) ).
	minMorph setVertices: { self center + p1 . self center + p2 }.
	self updateShadowMorph.! !

!PhdETServoPositionMorph methodsFor: 'as yet unclassified' stamp: 'pt 6/3/2009 16:28'!
updateShadowMorph

	shadowMorph
		circleCenter: self center;
		radius: self width / 2;
		angleA: max;
		angleB: min.! !

!PhdETServoPositionMorph methodsFor: 'as yet unclassified' stamp: 'pt 6/3/2009 16:27'!
updateSubmorphs

	self
		updateMinMorph;
		updateMaxMorph;
		updateCurrentMorph;
		updateShadowMorph.! !

BorderedMorph subclass: #PhdETPhidget
	instanceVariableNames: 'phidHandle labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

PhdETPhidget subclass: #PhdETAccelerometer
	instanceVariableNames: 'gyroMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

!PhdETAccelerometer class methodsFor: 'as yet unclassified' stamp: 'pt 7/1/2009 14:28'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."
	^ #(
		#(
			#Phidget
			#(
				#(
					#slot
					#Attached
					'This is whether the Phidget is attached to the USB port or not.'
					#Boolean
					#readOnly
					#Player
					#getAttached
					#unused
					#unused
				)
				#(
					#slot
					#RotationAroundX
					'Rotation around the x-axis. (-90.0 - 90.0)'
					#Float
					#readOnly
					#Player
					#getAcclRotationAroundX
					#unused
					#unused
				)
				#(
					#slot
					#RotationAroundY
					'Rotation around the y-axis. (-90.0 - 90.0)'
					#Float
					#readOnly
					#Player
					#getAcclRotationAroundY
					#unused
					#unused
				)
				#(
					#slot
					#RotationAroundZ
					'Rotation around the z-axis. (-90.0 - 90.0)'
					#Float
					#readOnly
					#Player
					#getAcclRotationAroundZ
					#unused
					#unused
				)
				#(
					#slot
					#RotationAroundXNumber
					'Rotation around the x-axis mapped to a Number between 0 and 1000.'
					#Number
					#readOnly
					#Player
					#getAcclRotationAroundXNumber
					#unused
					#unused
				)
				#(
					#slot
					#RotationAroundYNumber
					'Rotation around the y-axis mapped to a Number between 0 and 1000.'
					#Number
					#readOnly
					#Player
					#getAcclRotationAroundYNumber
					#unused
					#unused
				)
				#(
					#slot
					#RotationAroundZNumber
					'Rotation around the z-axis mapped to a Number between 0 and 1000.'
					#Number
					#readOnly
					#Player
					#getAcclRotationAroundZNumber
					#unused
					#unused
				)
			)
		)
	)! !

!PhdETAccelerometer class methodsFor: 'as yet unclassified' stamp: 'pt 6/24/2009 09:38'!
descriptionForPartsBin
    ^ self partName:    'Accelerometer'
        categories:     #('Phidgets')
        documentation:  'This is a three axis accelerometer that measures 3 gravities change per axis. It measures both dynamic acceleration (vibration) and static acceleration (gravity or tilt).'! !

!PhdETAccelerometer methodsFor: 'as yet unclassified' stamp: 'pt 6/24/2009 10:06'!
angleToNumber: anAngle
	"Converts an angle (-90.0 - 90.0) to an Integer (0 - 1000)."
	
	^ anAngle asFloat + 90.0 / 180.0 * 1000.0! !

!PhdETAccelerometer methodsFor: 'events' stamp: 'pt 7/2/2009 14:28'!
attach
	phidHandle changeTrigger: 0.1.
	self updateGyroMorph.! !

!PhdETAccelerometer methodsFor: 'initialization' stamp: 'pt 7/3/2009 09:13'!
createAndAddSubmorphs

	super createAndAddSubmorphs.
	gyroMorph := PhdETGyroMorph new
						extent: 70@70;
						update;
						yourself.
	self addMorph: gyroMorph.! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 7/2/2009 12:17'!
getAcclRotationAroundX

	phidHandle isAttached ifFalse: [ ^ 0.0 ].
	^ (phidHandle axes at: 2) angleDegrees! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 6/24/2009 10:26'!
getAcclRotationAroundXNumber

	^ self angleToNumber: self getAcclRotationAroundX! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 7/2/2009 12:16'!
getAcclRotationAroundY

	phidHandle isAttached ifFalse: [ ^ 0.0 ].
	^ (phidHandle axes at: 3) angleDegrees! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 6/24/2009 10:26'!
getAcclRotationAroundYNumber

	^ self angleToNumber: self getAcclRotationAroundY! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 7/2/2009 12:16'!
getAcclRotationAroundZ

	phidHandle isAttached ifFalse: [ ^ 0.0 ].
	^ (phidHandle axes at: 1) angleDegrees! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 6/24/2009 10:26'!
getAcclRotationAroundZNumber

	^ self angleToNumber: self getAcclRotationAroundZ! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 7/2/2009 12:19'!
getDegreesX

	phidHandle isAttached ifFalse: [ ^ 0.0 ].
	^ (phidHandle axes at: 1) angleDegrees! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 7/2/2009 12:19'!
getDegreesY

	phidHandle isAttached ifFalse: [ ^ 0.0 ].
	^ (phidHandle axes at: 2) angleDegrees! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 7/2/2009 12:19'!
getDegreesZ

	phidHandle isAttached ifFalse: [ ^ 0.0 ].
	^ (phidHandle axes at: 3) angleDegrees! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 7/2/2009 12:18'!
getRadiansX

	phidHandle isAttached ifFalse: [ ^ 0.0 ].
	^ (phidHandle axes at: 1) angleRadians! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 7/2/2009 12:18'!
getRadiansY

	phidHandle isAttached ifFalse: [ ^ 0.0 ].
	^ (phidHandle axes at: 2) angleRadians! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 7/2/2009 12:18'!
getRadiansZ

	phidHandle isAttached ifFalse: [ ^ 0.0 ].
	^ (phidHandle axes at: 3) angleRadians! !

!PhdETAccelerometer methodsFor: 'initialization' stamp: 'pt 7/2/2009 14:27'!
initialize
	self 
		initPhidget: PhdCrAccelerometer new
		withLabel: 'Accelerometer';
		width: 150;
		height: 110;
		initializeGyroMorph.
		
	phidHandle
		on: #Attach             do: [ self attach ];
		on: #Detach             do: [ self updateGyroMorph ];
		on: #AccelerationChange do: [ self updateGyroMorph ].! !

!PhdETAccelerometer methodsFor: 'initialization' stamp: 'pt 7/2/2009 13:34'!
initializeGyroMorph
		
	self positionGyroMorph.! !

!PhdETAccelerometer methodsFor: 'initialization' stamp: 'pt 6/24/2009 09:53'!
initializeToStandAlone
	
	self initialize.! !

!PhdETAccelerometer methodsFor: 'accessing' stamp: 'pt 7/3/2009 09:12'!
positionGyroMorph

	gyroMorph center: self center - (0 @ -10)! !

!PhdETAccelerometer methodsFor: 'events' stamp: 'pt 7/2/2009 12:20'!
updateGyroMorph

	gyroMorph
		x: self getRadiansX;
		y: self getRadiansY;
		z: self getRadiansZ;
		update.! !

!PhdETPhidget class methodsFor: 'as yet unclassified' stamp: 'pt 5/28/2009 14:26'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."
	^ #(
		(Phidget (
			(slot Label 'The label of this Phidget.' String readWrite Player getLabel Player setLabel:)
			(slot Attached 'This is wether the Phidget is attached to the USB port or not.' Boolean readOnly Player getAttached unused unused)
		))
	)

! !

!PhdETPhidget methodsFor: 'private' stamp: 'pt 5/28/2009 14:38'!
adaptSize
	"Adjusts submorphs to fit perfectly - even if I was resized."
	
	self positionLabel.! !

!PhdETPhidget methodsFor: 'private' stamp: 'pt 5/28/2009 14:26'!
changed
	super changed.
	self adaptSize.! !

!PhdETPhidget methodsFor: 'initialization' stamp: 'pt 5/28/2009 14:54'!
createAndAddSubmorphs
	
	"create and add label"
	labelMorph := StringMorph new font: (TextStyle default fontAt: 2) emphasis: 1.
	self addMorph: labelMorph.! !

!PhdETPhidget methodsFor: 'submorphs-add/remove' stamp: 'pt 5/28/2009 14:41'!
delete
	phidHandle close.
	super delete.! !

!PhdETPhidget methodsFor: 'accessing' stamp: 'lk 6/15/2009 12:10'!
getAttached
	^ phidHandle isAttached! !

!PhdETPhidget methodsFor: 'accessing' stamp: 'pt 5/28/2009 14:31'!
getLabel
	^ labelMorph contents! !

!PhdETPhidget methodsFor: 'initialization' stamp: 'pt 5/28/2009 14:53'!
initPhidget: aPhidHandle withLabel: aLabel
	
	super initialize.
	phidHandle := aPhidHandle.
	self createAndAddSubmorphs.
	
	"Set standard size and color."
	self
		setLabel: aLabel;
		width: 290;
		height: 75;
		color: (Color r: 0.4 g: 0.7 b: 0.4);
		useRoundedCorners.
	
	"open the phidget, so that it's ready to be used"
	phidHandle openAny.! !

!PhdETPhidget methodsFor: 'private' stamp: 'pt 5/28/2009 14:31'!
positionLabel

	labelMorph position: self center - ( labelMorph width / 2 @ ( self height / 2 - 4 ) ).! !

!PhdETPhidget methodsFor: 'accessing' stamp: 'pt 5/28/2009 14:32'!
setLabel: anObject

	labelMorph contents: anObject asString.
	(self player) ifNotNil: [
		self player setName: labelMorph contents ].
	self adaptSize.
! !

PhdETPhidget subclass: #PhdETPortBasedPhidget
	instanceVariableNames: 'ports bin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

PhdETPortBasedPhidget subclass: #PhdETInterfaceKit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

!PhdETInterfaceKit class methodsFor: 'as yet unclassified' stamp: 'pt 5/3/2009 19:18'!
descriptionForPartsBin
    ^ self partName:    'InterfaceKit'
        categories:     #('Phidgets')
        documentation:  'An Interface Kit'! !

!PhdETInterfaceKit methodsFor: 'events' stamp: 'pt 6/30/2009 12:42'!
attach
	"this method is called if the interface kit was attached."! !

!PhdETInterfaceKit methodsFor: 'initialization' stamp: 'pt 6/3/2009 01:49'!
collectPortDescriptorQuads
	"Lists the Ports I want to show."

	| quads |
	quads := OrderedCollection new.
	PhdETIfKitInputPort addPortDescriptorQuadsTo: quads.
	PhdETIfKitOutputPort addPortDescriptorQuadsTo: quads.
	PhdETIfKitSensorPort addPortDescriptorQuadsTo: quads.
	^ quads! !

!PhdETInterfaceKit methodsFor: 'events' stamp: 'pt 6/30/2009 12:42'!
detach
	"this method is called if the interface kit was detached"! !

!PhdETInterfaceKit methodsFor: 'accessing' stamp: 'pt 7/1/2009 14:59'!
getInput: index

	(phidHandle isAttached and: [phidHandle inputs indexIsInRange: index]) ifTrue: [
		^ (phidHandle inputs at: index) value ].

	^ false! !

!PhdETInterfaceKit methodsFor: 'accessing' stamp: 'pt 7/1/2009 14:59'!
getOutput: index

	(phidHandle isAttached and: [phidHandle outputs indexIsInRange: index]) ifTrue: [
		^ (phidHandle outputs at: index) value ].

	^ false! !

!PhdETInterfaceKit methodsFor: 'accessing' stamp: 'pt 7/1/2009 15:00'!
getSensor: index

	(phidHandle isAttached and: [phidHandle sensors indexIsInRange: index]) ifTrue: [
		^ (phidHandle sensors at: index) value ].

	^ 0! !

!PhdETInterfaceKit methodsFor: 'initialization' stamp: 'pt 6/30/2009 12:49'!
initialize
	self initPhidget: PhdCrInterfaceKit new withLabel: 'Interface Kit'.
	
	phidHandle
		on: #Attach do: [ self attach ];
		on: #Detach do: [ self detach ];
		on: #InputChange do: [ self inputChange ];
		on: #OutputChange do: [ self outputChange ];
		on: #SensorChange do: [ self sensorChange ].! !

!PhdETInterfaceKit methodsFor: 'initialization' stamp: 'pt 6/30/2009 12:49'!
initializeToStandAlone
	self initialize.! !

!PhdETInterfaceKit methodsFor: 'events' stamp: 'pt 6/30/2009 12:43'!
inputChange
	"This method is called if an inputValue has changed.
	We update our visible inputPorts here."
	self ports do: [:port | port update: #inputPort].! !

!PhdETInterfaceKit methodsFor: 'accessing' stamp: 'pt 7/1/2009 15:13'!
inputPortAvailable: portNumber
	^ phidHandle isAttached and: [ phidHandle inputs indexIsInRange: portNumber ]! !

!PhdETInterfaceKit methodsFor: 'events' stamp: 'pt 6/30/2009 12:43'!
outputChange
	"This method is called if an outputValue has changed.
	We update our visible outputPorts here."
	self ports do: [:port | port update: #outputPort].! !

!PhdETInterfaceKit methodsFor: 'accessing' stamp: 'pt 7/1/2009 15:14'!
outputPortAvailable: portNumber
	^ phidHandle isAttached and: [ phidHandle outputs indexIsInRange: portNumber ]! !

!PhdETInterfaceKit methodsFor: 'events' stamp: 'pt 6/30/2009 12:44'!
sensorChange
	"This method is called if a sensorValue has changed.
	We update our visible sensorPorts here."
	self ports do: [:port | port update: #sensorPort].! !

!PhdETInterfaceKit methodsFor: 'accessing' stamp: 'pt 7/1/2009 15:15'!
sensorPortAvailable: portNumber
	^ phidHandle isAttached and: [ phidHandle sensors indexIsInRange: portNumber ]! !

!PhdETInterfaceKit methodsFor: 'accessing' stamp: 'pt 7/1/2009 15:11'!
setOutput: index to: aBoolean

	(phidHandle isAttached and: [phidHandle outputs indexIsInRange: index]) ifTrue: [
		^ (phidHandle outputs at: index) value: aBoolean ].
	^ false! !

!PhdETPortBasedPhidget methodsFor: 'as yet unclassified' stamp: 'pt 5/28/2009 14:38'!
adaptSize
	"Adjusts submorphs to fit perfectly - even if I was resized."
	
	self positionBin.
	self positionLabel.! !

!PhdETPortBasedPhidget methodsFor: 'initialization' stamp: 'pt 5/28/2009 17:09'!
createAndAddSubmorphs
	
	"create and add bin"
	super createAndAddSubmorphs.
	bin := self createBin.
	self addMorph: bin.! !

!PhdETPortBasedPhidget methodsFor: 'initialization' stamp: 'pt 5/28/2009 12:04'!
createBin
	
	| oldResizing aBin |
	aBin := (PhdETPartsBin newPartsBinWithOrientation: #leftToRight from: #())
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		setNameTo: 'Ports';
		dropEnabled: false;
		useRoundedCorners;
		controlingMorph: self;
		yourself.

	oldResizing := aBin vResizing.
	aBin
		listDirection: #leftToRight quadList: self collectPortDescriptorQuads;
		vResizing: oldResizing;
		layoutChanged;
		fullBounds.
		
	^ aBin! !

!PhdETPortBasedPhidget methodsFor: 'submorphs-add/remove' stamp: 'pt 5/28/2009 17:09'!
delete
	ports reverseDo: [ :port | port delete ].
	super delete.! !

!PhdETPortBasedPhidget methodsFor: 'initialization' stamp: 'pt 5/28/2009 17:09'!
initPhidget: aPhidHandle withLabel: aLabel
	
	ports := OrderedCollection new.
	super initPhidget: aPhidHandle withLabel: aLabel.	
	bin color: self color lighter lighter.! !

!PhdETPortBasedPhidget methodsFor: 'port handling' stamp: 'pt 6/30/2009 12:28'!
ports
	^ ports! !

!PhdETPortBasedPhidget methodsFor: 'private' stamp: 'pt 5/28/2009 17:09'!
positionBin
		
	bin
		height: self height - 20;
		top: self top + 17;
		width: self width - 6;
		left: self left + 3.! !

!PhdETPortBasedPhidget methodsFor: 'port handling' stamp: 'pt 5/28/2009 17:10'!
registerPort: aPort
	"If a new Port was draged out of me, it registeres itself here."
	
	ports add: aPort.! !

!PhdETPortBasedPhidget methodsFor: 'port handling' stamp: 'pt 5/28/2009 17:10'!
unregisterPort: aPort
	"If a new Port was draged out of me, it registeres itself here."
	
	ports remove: aPort ifAbsent: [].! !

PhdETPhidget subclass: #PhdETServo1Motor
	instanceVariableNames: 'motorMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

!PhdETServo1Motor class methodsFor: 'as yet unclassified' stamp: 'pt 6/4/2009 08:53'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."
	^ #(
		#(
			#Phidget
			#(
				#(
					#slot
					#Attached
					'This is wether the Phidget is attached to the USB port or not.'
					#Boolean
					#readOnly
					#Player
					#getAttached
					#unused
					#unused
				)
				#(
					#slot
					#MinPosition
					'This is minimum position the servo motor can handle.'
					#Float
					#readOnly
					#Player
					#getServo1MotorMinPosition
					#unused
					#unused
				)
				#(
					#slot
					#MaxPosition
					'This is maximum position the servo motor can handle.'
					#Float
					#readOnly
					#Player
					#getServo1MotorMaxPosition
					#unused
					#unused
				)
				#(
					#slot
					#Position
					'This is the current position of the servo motor.'
					#Float
					#readWrite
					#Player
					#getServo1MotorCurrentPosition
					#Player
					#setServo1MotorCurrentPosition:
				)
				#(
					#slot
					#PositionInt
					'This is the current position of the servo motor maped as a Number between 0 and 1000.'
					#Number
					#readWrite
					#Player
					#getServo1MotorCurrentPositionNumber
					#Player
					#setServo1MotorCurrentPositionNumber:
				)
				#(
					#slot
					#Engaged
					'This is wether the servo motor is engaged or not.'
					#Boolean
					#readWrite
					#Player
					#getServo1MotorEngaged
					#Player
					#setServo1MotorEngaged:
				)
			)
		)
	)! !

!PhdETServo1Motor class methodsFor: 'as yet unclassified' stamp: 'pt 5/29/2009 09:37'!
descriptionForPartsBin
    ^ self partName:    'Servo 1-Motor'
        categories:     #('Phidgets')
        documentation:  'A Servo Board which connects to 1 servo motor.'! !

!PhdETServo1Motor methodsFor: 'events' stamp: 'pt 6/3/2009 16:30'!
attach
	"Sets motorMorph values for my motorMorph if I was attached."
	self
		setMotorMorphMin;
		setMotorMorphMax;
		setMotorMorphCurrent.! !

!PhdETServo1Motor methodsFor: 'initialization' stamp: 'pt 7/2/2009 11:52'!
createAndAddSubmorphs

	super createAndAddSubmorphs.
	motorMorph := PhdETServoPositionMorph new.
	self addMorph: motorMorph.! !

!PhdETServo1Motor methodsFor: 'events' stamp: 'pt 6/24/2009 10:01'!
detach
	"Sets motorMorph values to zero if I was attached."
	
	motorMorph
		min: 0.0;
		max: 0.0;
		current: 0.0.! !

!PhdETServo1Motor methodsFor: 'accessing' stamp: 'pt 6/24/2009 10:01'!
getCurrentPosition
	
	(phidHandle motors indexIsInRange: 1) ifFalse: [ ^ 0 ].
	^ (phidHandle motors at: 1) position! !

!PhdETServo1Motor methodsFor: 'accessing' stamp: 'lk 6/16/2009 12:24'!
getCurrentPositionNumber
	"Calculates the motor position number relative to the intervall [0, 1000].
	aNumber=0 means that the position is set to minPosition.
	aNumber=1000 means that the position ist set to maxPosition."

	| curPosition max min |
	curPosition := self getCurrentPosition.
	max := self getMaxPosition.
	min := self getMinPosition.
	(min - max) rounded == 0 ifTrue: [ ^ 0 ].
	^ curPosition - min * 1000 / ( max - min ) rounded! !

!PhdETServo1Motor methodsFor: 'accessing' stamp: 'lk 6/16/2009 12:19'!
getEngaged

	(phidHandle motors indexIsInRange: 1) ifFalse: [ ^ false ].
	^ (phidHandle motors at: 1) isEngaged! !

!PhdETServo1Motor methodsFor: 'accessing' stamp: 'pt 6/24/2009 10:02'!
getMaxPosition

	(phidHandle motors indexIsInRange: 1) ifFalse: [ ^ 0 ].
	^ (phidHandle motors at: 1) positionMax! !

!PhdETServo1Motor methodsFor: 'accessing' stamp: 'pt 6/24/2009 10:02'!
getMinPosition

	(phidHandle motors indexIsInRange: 1) ifFalse: [ ^ 0 ].
	^ (phidHandle motors at: 1) positionMin! !

!PhdETServo1Motor methodsFor: 'initialization' stamp: 'pt 6/30/2009 12:48'!
initialize
	self 
		initPhidget: PhdCrServo new
		withLabel: 'Servo Board'.
	self
		width: 110;
		height: 83;
		initializeMotorMorph.
		
	phidHandle
		on: #Attach do: [ self attach ];
		on: #Detach do: [ self detach ];
		on: #PositionChange do: [ self positionChange ].! !

!PhdETServo1Motor methodsFor: 'initialization' stamp: 'pt 6/30/2009 12:48'!
initializeMotorMorph

	self
		setMotorMorphMin;
		setMotorMorphMax;
		setMotorMorphCurrent;
		positionMotorMorph.! !

!PhdETServo1Motor methodsFor: 'initialization' stamp: 'pt 6/3/2009 01:47'!
initializeToStandAlone
	
	self initialize.! !

!PhdETServo1Motor methodsFor: 'events' stamp: 'pt 6/24/2009 12:04'!
positionChange
	"Sets motorMorph position to the current position if my position changed."
	
	self setMotorMorphCurrent.! !

!PhdETServo1Motor methodsFor: 'initialization' stamp: 'pt 6/3/2009 02:11'!
positionMotorMorph

	motorMorph position: self center - ((motorMorph width / 2) @ (self height / 2 - 30))! !

!PhdETServo1Motor methodsFor: 'accessing' stamp: 'pt 6/24/2009 09:59'!
setCurrentPosition: aFloat

	phidHandle isAttached ifFalse: [ ^ self ].
	^ (phidHandle motors at: 1) position: aFloat! !

!PhdETServo1Motor methodsFor: 'accessing' stamp: 'pt 6/16/2009 14:40'!
setCurrentPositionNumber: aNumber
	"Sets the motor position to a value relative to aNumber.
	aNumber=0 means that the position is set to minPosition.
	aNumber=1000 means that the position ist set to maxPosition."

	| max min |
	( 0 <= aNumber and: [ aNumber <= 1000 ] ) ifFalse: [ ^ self ].
	max := self getMaxPosition.
	min := self getMinPosition.
	min == -1000 ifFalse: [
		self setCurrentPosition: max - min * (aNumber asFloat) / 1000.0 + min ].! !

!PhdETServo1Motor methodsFor: 'accessing' stamp: 'lk 6/21/2009 12:12'!
setEngaged: aBoolean

	^ (phidHandle motors at: 1) isEngaged: aBoolean! !

!PhdETServo1Motor methodsFor: 'as yet unclassified' stamp: 'pt 6/24/2009 09:58'!
setMotorMorphCurrent

	motorMorph current: (self getCurrentPosition asSmallPositiveDegrees).! !

!PhdETServo1Motor methodsFor: 'as yet unclassified' stamp: 'pt 6/24/2009 09:58'!
setMotorMorphMax

	motorMorph max: (self getMaxPosition asSmallPositiveDegrees).! !

!PhdETServo1Motor methodsFor: 'as yet unclassified' stamp: 'pt 6/24/2009 09:58'!
setMotorMorphMin

	motorMorph min: (self getMinPosition asSmallPositiveDegrees).! !

BorderedMorph subclass: #PhdETPort
	instanceVariableNames: 'phidget portNumber numberString wire'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

PhdETPort subclass: #PhdETIfKitInputPort
	instanceVariableNames: 'statusMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

!PhdETIfKitInputPort class methodsFor: 'as yet unclassified' stamp: 'pt 5/8/2009 08:57'!
additionsToViewerCategoryInputPort
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."
	
	^ #(
		InputPort (
			(slot Value 'The value at the digital Intput port on an Interface Kit.' Boolean readOnly Player getIfKitInputValue unused unused)
			(slot PortNumber 'The index of this digital Input port.' Number readWrite Player getPortNumber Player setPortNumber:)
			(slot ShowWire 'This is wether a wire from this port to its Phidget is shown..' Boolean readWrite Player getShowWire Player setShowWire:)
		)
	)! !

!PhdETIfKitInputPort class methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 08:32'!
portDescription

	^  self
		partName:		'Digital Input'
		categories:		#('Interface Kit')
		documentation:	'An port to a digital input of an Interface Kit. This port is bound to a port of the Interface Kit hardware. With me it is possible to read wether the port returns true or false.'.! !

!PhdETIfKitInputPort class methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:56'!
portType
	"Returns the type of the port. This method is called to check the port type when updating the ports appereance."
	^ #inputPort! !

!PhdETIfKitInputPort methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 17:02'!
createAndAddStatusMorph

	statusMorph := PhdETOnOffStatusMorph new.
	self addMorph: statusMorph.
	statusMorph
		position: ( self width // 2 - ( statusMorph width // 2 ) ) @ ( self bottom - statusMorph height - 5 ).! !

!PhdETIfKitInputPort methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:58'!
getIfKitInputValue

	^ phidget getInput: portNumber.! !

!PhdETIfKitInputPort methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 16:56'!
initialize
	super initialize.
	self
		color: Color red lighter;
		height: 70;
		createAndAddStatusMorph;
		update: self class portType.! !

!PhdETIfKitInputPort methodsFor: 'as yet unclassified' stamp: 'pt 6/2/2009 10:34'!
isInRange: aNumber
	
	^ phidget sensorPortAvailable: aNumber! !

!PhdETIfKitInputPort methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:59'!
setStatus: aBoolean

	statusMorph setStatus: aBoolean.! !

!PhdETIfKitInputPort methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:58'!
update: type
	"Update my appereance if my value possibly has changed."
	type = self class portType ifTrue: [self setStatus: self getIfKitInputValue].! !

PhdETPort subclass: #PhdETIfKitOutputPort
	instanceVariableNames: 'statusMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

!PhdETIfKitOutputPort class methodsFor: 'as yet unclassified' stamp: 'pt 5/8/2009 08:58'!
additionsToViewerCategoryOutputPort
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."

	^ #(
		OutputPort (
			(slot Value 'The value at the digital Output port on an Interface Kit.' Boolean readWrite Player getIfKitOutputValue Player setIfKitOutputValue:)
			(slot PortNumber 'The index of this digital Output port.' Number readWrite Player getPortNumber Player setPortNumber:)
			(slot ShowWire 'This is wether a wire from this port to its Phidget is shown..' Boolean readWrite Player getShowWire Player setShowWire:)
		)
	)! !

!PhdETIfKitOutputPort class methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 08:32'!
portDescription

	^  self
		partName:		'Digital Output'
		categories:		#('Interface Kit')
		documentation:	'An port to a digital output of an Interface Kit. This port is bound to a port of the Interface Kit hardware. With me it is possible to read wether the port returns true or false or set this value'.! !

!PhdETIfKitOutputPort class methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:56'!
portType
	"Returns the type of the port. This method is called to check the port type when updating the ports appereance."
	^ #outputPort! !

!PhdETIfKitOutputPort methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 17:03'!
createAndAddStatusMorph

	statusMorph := PhdETOnOffStatusMorph new.
	self addMorph: statusMorph.
	statusMorph
		position: ( self width // 2 - ( statusMorph width // 2 ) ) @ ( self bottom - statusMorph height - 5 ).! !

!PhdETIfKitOutputPort methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:53'!
getIfKitOutputValue

	^ phidget getOutput: portNumber.! !

!PhdETIfKitOutputPort methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 17:03'!
initialize
	super initialize.
	self
		color: Color blue muchLighter;
		height: 70;
		createAndAddStatusMorph;
		update: self class portType.! !

!PhdETIfKitOutputPort methodsFor: 'as yet unclassified' stamp: 'pt 6/2/2009 10:35'!
isInRange: aNumber
	
	^ phidget outputPortAvailable: aNumber! !

!PhdETIfKitOutputPort methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:53'!
setIfKitOutputValue: aBoolean

	^ phidget setOutput: portNumber to: aBoolean.! !

!PhdETIfKitOutputPort methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:59'!
setStatus: aBoolean

	statusMorph setStatus: aBoolean.! !

!PhdETIfKitOutputPort methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:57'!
update: type
	"Update my appereance if my value possibly has changed."
	type = self class portType ifTrue: [self setStatus: self getIfKitOutputValue].! !

PhdETPort subclass: #PhdETIfKitSensorPort
	instanceVariableNames: 'statusMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-EToys'!

!PhdETIfKitSensorPort class methodsFor: 'as yet unclassified' stamp: 'pt 6/4/2009 08:12'!
additionsToViewerCategorySensorPort
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."

	^ #(
		SensorPort (
			(slot Value 'The value at the analog Sensor port on an Interface Kit.' Number readOnly Player getIfKitSensorValue unused unused)
			(slot SensorPortNumber 'The index of this analog Sensor port.' Number readWrite Player getPortNumber Player setPortNumber:)
			(slot ShowWire 'This is wether a wire from this port to its Phidget is shown..' Boolean readWrite Player getShowWire Player setShowWire:)
		)
	)! !

!PhdETIfKitSensorPort class methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 08:32'!
portDescription

	^  self
		partName:		'Analog Sensor'
		categories:		#('Interface Kit')
		documentation:	'An port to an analog sensor of an Interface Kit. This port is bound to a port of the Interface Kit hardware. With me it is possible to read which value an attached analog sensor returns. This value is between 0 and 1000.'.! !

!PhdETIfKitSensorPort class methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:56'!
portType
	"Returns the type of the port. This method is called to check the port type when updating the ports appereance."
	^ #sensorPort! !

!PhdETIfKitSensorPort methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 17:06'!
createAndAddStatusMorph

	statusMorph := PhdETBarMorph new.
	self addMorph: statusMorph.
	statusMorph
		width: self width -10;
		height: 20;
		position: ( self width // 2 - ( statusMorph width // 2 ) ) @ ( self bottom - statusMorph height - 5 ).! !

!PhdETIfKitSensorPort methodsFor: 'as yet unclassified' stamp: 'pt 6/2/2009 10:35'!
getIfKitSensorValue
	^ phidget getSensor: portNumber! !

!PhdETIfKitSensorPort methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 17:08'!
initialize
	super initialize.
	self
		color: Color yellow lighter;
		height: 50;
		width: 100;
		createAndAddStatusMorph;
		update: self class portType;
		centerNumberString.! !

!PhdETIfKitSensorPort methodsFor: 'as yet unclassified' stamp: 'pt 6/2/2009 10:35'!
isInRange: aNumber
	
	^ phidget inputPortAvailable: aNumber! !

!PhdETIfKitSensorPort methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 17:01'!
setStatus: aNumber

	statusMorph value: aNumber.! !

!PhdETIfKitSensorPort methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:58'!
update: type
	"Update my appereance if my value possibly has changed."
	type = self class portType ifTrue: [self setStatus: self getIfKitSensorValue].! !

!PhdETPort class methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 08:17'!
addPortDescriptorQuadsTo: aList
	"analogous to addPartsDescriptorQuadsTo: aList if: aBlock from the Morph class"
	
	| info |
	info := self portDescription.
	aList add:
		{info globalReceiverSymbol.
		info nativitySelector.
		info formalName.
		info documentation.
		info sampleImageFormOrNil}.! !

!PhdETPort class methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 12:00'!
launchPartVia: aSelector label: aString phidget: aPhidget
	"Obtain a morph by sending aSelector to self, and attach it to the morphic hand.  This provides a general protocol for parts bins"

	| aMorph |
	aMorph := self perform: aSelector with: aPhidget.
	aMorph setNameTo: (ActiveWorld unusedMorphNameLike: aString).
	aMorph setProperty: #beFullyVisibleAfterDrop toValue: true.
	aMorph openInHand! !

!PhdETPort class methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 10:54'!
newStandAlone: aPhidget
	"Answer an instance capable of standing by itself as a usable morph."

	^ self basicNew initializeToStandAlone: aPhidget! !

!PhdETPort class methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 10:52'!
partName: aName categories: aList documentation: aDoc
	"Answer a DescriptionForPartsBin which will represent a launch of a new instance of my class via the #newStandAlone protocol sent to my class. Use the category-list and documentation provided"


	^ DescriptionForPartsBin new
		formalName: aName
		categoryList: aList
		documentation: aDoc
		globalReceiverSymbol: self name
		nativitySelector: #newStandAlone:! !

!PhdETPort class methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 08:18'!
portDescription

	self subclassResponsibility.
	! !

!PhdETPort class methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:57'!
portType
	"Returns the type of the port. This method is called to check the port type when updating the ports appereance."
	^ #abstractPort! !

!PhdETPort methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 17:08'!
centerNumberString

	| stringCenter topMiddle |
	topMiddle := (self width // 2)@15.
	stringCenter := (numberString width / 2)@( numberString height / 2).
	numberString position: self position + topMiddle - stringCenter.! !

!PhdETPort methodsFor: 'as yet unclassified' stamp: 'pt 6/2/2009 10:34'!
createWire
	wire := LineMorph new.
	self currentWorld addMorphBack: wire! !

!PhdETPort methodsFor: 'as yet unclassified' stamp: 'pt 7/3/2009 08:45'!
delete
	wire delete.
	phidget unregisterPort: self.
	(self owner isKindOf: TransformMorph) ifTrue: [owner delete].
	super delete.! !

!PhdETPort methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 09:28'!
getPortNumber
	^ portNumber! !

!PhdETPort methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 13:05'!
initialize
	super initialize.
	self useRoundedCorners.
	portNumber := 1.
	numberString := (StringMorph new
							contents: portNumber asString;
							emphasis: 1;
							yourself).
	self
		centerNumberString;
		addMorph: numberString.! !

!PhdETPort methodsFor: 'as yet unclassified' stamp: 'pt 6/2/2009 10:34'!
initializeToStandAlone: aPhidget
	phidget := aPhidget.
	phidget registerPort: self.
	self initialize.
	! !

!PhdETPort methodsFor: 'as yet unclassified' stamp: 'pt 5/7/2009 19:05'!
isInRange: aNumber
	"A subclass may override this, to allow changing portNumbers"
	^ false! !

!PhdETPort methodsFor: 'as yet unclassified' stamp: 'pt 7/2/2009 20:18'!
positionWire
	"Positions the Wire so that it reaches from the origin Phidgits to me. If the Wire doenstn exists, create it."

	"Cannot create Wire while initialisation, because that ruins my Thumbnail. So I do it here."
	wire ifNil: [ self createWire ].
	wire setVertices: {phidget referencePositionInWorld. self referencePositionInWorld}.! !

!PhdETPort methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 13:01'!
setPortNumber: aNumber
	( aNumber isInteger and: [ self isInRange: aNumber ] )
	ifTrue: [
		portNumber := aNumber.
		numberString contents: portNumber asString.
		self centerNumberString.
		self update: self class portType ]! !

!PhdETPort methodsFor: 'as yet unclassified' stamp: 'pt 5/8/2009 09:23'!
step
	self positionWire.! !

!PhdETPort methodsFor: 'as yet unclassified' stamp: 'pt 5/8/2009 09:22'!
stepTime
	^ 100! !

!PhdETPort methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:52'!
update: type
	"This method is called if a value of the phidget I belong has changed.
	This gives me the opportunity to update my appereance if the given type matches mine."
	self subclassResponsibility.! !

BorderedMorph subclass: #PhdLabConnector
	instanceVariableNames: 'connector type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Lab'!

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/7/2009 08:18'!
click: anEvent
	"ignore this event, wait for drag:"

	^ self! !

!PhdLabConnector methodsFor: 'accessing' stamp: 'sp 5/4/2009 21:12'!
connector

	^ connector! !

!PhdLabConnector methodsFor: 'accessing' stamp: 'sp 5/4/2009 21:13'!
connector: aPhdLbConnector

	connector := aPhdLbConnector.! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/7/2009 08:46'!
doubleClick: anEvent
	"ignore this event, wait for drag:"

	^ self! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/9/2009 23:50'!
drag: anEvent
	"currently not in use!!!!!!!!!!!!!!!!!!!!"
	
	| wire |
	wire :=  PhdLabWire
		from: self center 
		to: self currentWorld activeHand cursorPoint.
"	wire dragEvent: anEvent."
	wire
		openInWorld;
		startStepping.

	"anEvent hand addEventListener: wire"! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/9/2009 23:31'!
enableDrop: aBoolean

	^ true! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/9/2009 23:46'!
firstClickTimedOut: anEvent
	"start drag with hand grabbing wire"
	
	| wire |
	wire :=  PhdLabWire
		from: self center 
		to: self currentWorld activeHand cursorPoint.
"	wire dragEvent: anEvent."
	wire
		openInWorld;
		startStepping.

	anEvent hand grabMorph: wire.
	"anEvent hand addEventListener: wire"! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/7/2009 08:01'!
handlesMouseDown: anEvent

	^ true! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/8/2009 10:48'!
handlesMouseUp: anEvent

	^ true! !

!PhdLabConnector methodsFor: 'initialize' stamp: 'sp 5/9/2009 23:16'!
initialize

	super initialize.
	
	self
		connector: nil;
		type: #unknown;
		
		color: ( Color r: 0.816 g: 0.812 b: 0.812 );
		extent: 20@20;
		borderWidth: 1;
		useRoundedCorners.! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/9/2009 23:51'!
mouseDown: anEvent
	"when mouseDown-event inform the hand to watch for a drag: message (do we have to catch the other events??-like click)"

	"catch if okToPickUp is ok??" "what happend when user doesn't drag?'"
	
	anEvent hand 
		waitForClicksOrDrag: self
		event: anEvent
		selectors: #(#click: #doubleClick: #firstClickTimedOut: nil)	"#drag-->nil"
		threshold: 3.! !

!PhdLabConnector methodsFor: 'accessing' stamp: 'sp 5/4/2009 21:13'!
type

	^ type! !

!PhdLabConnector methodsFor: 'accessing' stamp: 'sp 5/4/2009 21:14'!
type: aSymbol
	"or we take two methods isInput and isOutput"

	type := aSymbol.! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/9/2009 23:56'!
wantsDroppedMorph: aMorph event: anEvent 
	"ask if it's a wire'"
	
	( aMorph isKindOf: PhdLabWire )		"wir sollten ja nicht kindOf nehm"
	ifTrue: [ ^ true "&..."]		"i/o abfragen msste der owner vom Connector dann wissen"
	ifFalse: [^ false]				"--> ^ self owner is***"! !

BorderedMorph subclass: #PhdLabInterfaceKit
	instanceVariableNames: 'ifKit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Lab'!

BorderedMorph subclass: #PhdLabSlider
	instanceVariableNames: 'pick max min maxValue minValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Lab'!

!PhdLabSlider methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:00'!
initialize

	super initialize.
	self color: Color blue lighter;
		width: 50;
		height: 200.
	pick := BorderedMorph new.
	pick color: Color black;
		width: 40;
		height: 20.
	self addMorph: pick.
	pick
		left: ( self left + 5 );
		top: ( self top + 5 ).
	min := 0.
	max := ( self bottom - 5 ) - ( self top + 5 ) - pick height.
	minValue := 0.
	maxValue := 100.
	! !

!PhdLabSlider methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:02'!
rawValue: aNumber
	"0 <= aNumber <= 1000"
	"pick top: self bottom - 5 - pick height - (aNumber/1000*max)."

	pick top: self top + 5 + ( ( 1000 - aNumber ) / 1000 * max ).! !

!PhdLabSlider methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:26'!
setMin: aSmallNumber andMax: aBigNumber

	minValue := aSmallNumber.
	maxValue := aBigNumber.! !

!PhdLabSlider methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:40'!
value

	^ ( pick top - self top - 5 ) * maxValue / minValue! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:50'!
getAcclRotationAroundX
	"Answers the current Rotation around the x-axis of an 3-axis accelerometer."

	^ self targetMorph getAcclRotationAroundX! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:50'!
getAcclRotationAroundXNumber
	"Answers the current Rotation around the x-axis of an 3-axis accelerometer - mapped to a number between 0 and 1000."

	^ self targetMorph getAcclRotationAroundXNumber! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:50'!
getAcclRotationAroundY
	"Answers the current Rotation around the y-axis of an 3-axis accelerometer."

	^ self targetMorph getAcclRotationAroundY! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:50'!
getAcclRotationAroundYNumber
	"Answers the current Rotation around the y-axis of an 3-axis accelerometer - mapped to a number between 0 and 1000."

	^ self targetMorph getAcclRotationAroundYNumber! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:50'!
getAcclRotationAroundZ
	"Answers the current Rotation around the z-axis of an 3-axis accelerometer."

	^ self targetMorph getAcclRotationAroundZ! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:50'!
getAcclRotationAroundZNumber
	"Answers the current Rotation around the z-axis of an 3-axis accelerometer - mapped to a number between 0 and 1000."

	^ self targetMorph getAcclRotationAroundZNumber! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:50'!
getAttached
	"Answers wether an Interface Kit is attached or not."

	^ self targetMorph getAttached! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:50'!
getIfKitInputValue
	"Answer the value of an Interface Kits digital input."

	^ self targetMorph getIfKitInputValue! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:50'!
getIfKitOutputValue
	"Answer the value of an Interface Kits digital output."

	^ self targetMorph getIfKitOutputValue! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:49'!
getIfKitSensorValue
	"Answer the value of an Interface Kits analog sensor."
	^ self targetMorph getIfKitSensorValue! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:51'!
getLabel
	"Answers the label of a Phidget"

	^ self targetMorph getLabel! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:49'!
getPortNumber
	"Answers the index of a Phidget port."
	^ self targetMorph getPortNumber! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:51'!
getServo1MotorCurrentPosition
	"Get the servo motors positio in the intervall [0,10000]."

	^ self targetMorph getCurrentPosition! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:51'!
getServo1MotorCurrentPositionNumber
	"Get the servo motors position."

	^ self targetMorph getCurrentPositionNumber! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:51'!
getServo1MotorEngaged
	"This is wether the motor is engaged or not"

	^ self targetMorph getEngaged! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:51'!
getServo1MotorMaxPosition
	"Get the servo maximum position."
	
	^ self targetMorph getMaxPosition! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:51'!
getServo1MotorMinPosition
	"Get the servo minimum position."
	
	^ self targetMorph getMinPosition! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:51'!
setIfKitOutputValue: value
	"Set the value of a Phidget Port"

	^ self targetMorph setIfKitOutputValue: value! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:51'!
setLabel: anObject
	"Sets the label of a Phidget"

	^ self targetMorph setLabel: anObject! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:52'!
setPortNumber: aNumber
	"Answers the index of a Phidget port."

	^ self targetMorph setPortNumber: aNumber! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:52'!
setServo1MotorCurrentPosition: aFloat 
	"Set the servo motors position."
	
	^ self targetMorph setCurrentPosition: aFloat! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:52'!
setServo1MotorCurrentPositionNumber: aNumber 
	"Set the servo motors position in an Intervall of 0 to 10,000"
	
	^ self targetMorph setCurrentPositionNumber: aNumber! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:52'!
setServo1MotorEngaged: aBoolean 
	"This is wether the motor is engaged or not"
	
	^ self targetMorph setEngaged: aBoolean! !

!Player methodsFor: '*Phidget-EToys' stamp: 'pt 7/3/2009 13:49'!
targetMorph
	"if the my costume is a TransformationMorph (-> the original Morph was rotated) don't return '"
	(self costume isKindOf: TransformationMorph) ifTrue: [ ^ self costume renderedMorph ].
	^ self costume! !
